################################################################################
# Module to find ADST packages                                                 #
#                                                                              #
# This module sets:                                                            #
#      ADST_FOUND                                                              #
#      ADST_LIBRARIES                                                          #
#      ADST_INCLUDE_DIR                                                        #
#                                                                              #
################################################################################

if (NOT ADST_FIND_QUIETLY)
  message(STATUS "Searching for ADST libraries")
endif (NOT ADST_FIND_QUIETLY)


# Search directories for the CDAS STCoordinates library.
set (DIRECTORIES
  $ENV{ADSTROOT}
  $ENV{ADSTROOT}/src	
  $ENV{ADSTROOT}/include	
  $ENV{ADSTROOT}/RecEvent/src	
  $ENV{ADSTROOT}/lib
  $ENV{AUGEROFFLINEROOT}
  $ENV{AUGEROFFLINEROOT}/lib	
  $ENV{AUGEROFFLINEROOT}/include/adst
)

find_path (ADST_INCLUDE_DIR RecEvent.h ${DIRECTORIES})
find_library (ADST_LIBRARIES RecEventKG ${DIRECTORIES})

set (ADST_FOUND TRUE)

if (NOT ADST_INCLUDE_DIR)
   set (ADST_FOUND FALSE)
endif (NOT ADST_INCLUDE_DIR)

if (NOT ADST_LIBRARIES)
   set (ADST_FOUND FALSE)
endif (NOT ADST_LIBRARIES)

if (ADST_FOUND)
   set (HAVE_ADST 1)
   set (ADST_CPPFLAGS "-I${ADST_INCLUDE_DIR}")
   set (ADST_LDFLAGS "-L${ADST_LIBRARY_DIR} -lRecEventKG -lAnalysisKG")
endif (ADST_FOUND) 
