#include "TROOT.h"
#include "TApplication.h"
#include "stdio.h"
#include <csignal>

#include "ED.h"
#include "ED_Files.h"

EDMainFrame *mainWin;
std::string startEvent = "";
std::string gDataFilePath = "/";
extern std::vector <RFile> gRootfiles;

int main (int argc, char *argv[]) {
  switch (argc) {
  case 1:
    cout<<"You can start ED by giving directly an event id or a file name, try next time:\n./ED.exe <event id/file(s) name(s)>"<<endl;
    break;
  case 2:
    if(strstr((const char *)argv[1],".root")) 
      gRootfiles.push_back(argv[1]);
    else startEvent = argv[1];
    break;
  default:
    for(int i=1; i<argc; i++) {
      if(strstr((const char *)argv[i],".root")) {
        gRootfiles.push_back(argv[i]);
      }
    }
    if(!gRootfiles.size()) {
      cout << "Usage: " << argv[0] << endl;
      cout << "or: " << argv[0] << " <event id>" <<endl;
      cout << "or: " << argv[0] << " <ROOT file(s)>" <<endl;
      return 1;
    }
    break;
  }

  TApplication theApp ("App", NULL, 0);

  mainWin = new EDMainFrame(gClient->GetRoot(), 1024, 700);
  if(gRootfiles.size() && startEvent=="")
    mainWin->UpdateFile();

  theApp.Run ();
  return 0;
}
