#ifndef EDCONFIG_H
#define EDCONFIG_H

#include <vector>
#include <string>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <TGMenu.h>
#include <TGButton.h>

#define MENUOFFSET 500

class EDConfig {
private:
  std::vector<std::string> fName;
  std::vector<std::string> fValue;
  std::vector<TGPopupMenu*> fMenu;

public:
  EDConfig() {};
  ~EDConfig() {};
  
  char *BuildName(const char*);
  const char* Get(const char *);
  void Set(const char*,const char*);
  void Add(TGPopupMenu *,const char*, const char*);
  void Add(const char*, const char*);
  TGCheckButton *CheckButton(TGGroupFrame *,const char *,const char *);
  void Load(const char *);
  void Save(const char *);
  int GetInt(const char *);
  int GetInt(int);
  void SetInt(const char *, int);
  void SetInt(int, int);
  int GetSig(const char*);
  int GetMinSig() {
    return MENUOFFSET;
  }
  int GetMaxSig() {
    return MENUOFFSET+fName.size();
  }
  void CheckMenu(int);
  void CheckSetMenu(int);
  void UnCheckUnSetMenu(int);
  std::vector<std::string> Names(){
    return fName;
  }
  std::vector<std::string> Values() {
    return fValue;
  }
};

#endif
