#include "EDDataFilePath.h"
#include <sstream>

extern std::string gDataFilePath;

enum MessageId {
  ENTER
};

EDDataFilePath::EDDataFilePath(const TGWindow *p,const TGWindow *main, UInt_t w, UInt_t h) : TGTransientFrame(p, main, w, h) {

  if(main)
    fMain = (EDMainFrame *)main;
  else
    return;

  unsigned long colordefault, colorred;
  gClient->GetColorByName("AntiqueWhite3",colordefault);
  gClient->GetColorByName("IndianRed1",colorred);

  fGF1 = new TGGroupFrame(this, "Enter data file path", kVerticalFrame);
  fGF1->ChangeBackground(colordefault);
  fHF = new TGHorizontalFrame(fGF1,100,30,kChildFrame,fgDefaultFrameBackground);
  fHF->ChangeBackground(colordefault);
  fHF->SetLayoutManager(new TGMatrixLayout(fHF,0,2,5,5));

  fMax = new TGLayoutHints(kLHintsExpandX);
  fMaxY = new TGLayoutHints(kLHintsExpandX| kLHintsExpandY);
  fLayout = new TGLayoutHints(kLHintsExpandX | kLHintsCenterX | kLHintsCenterY);

  fName = new TGTextEntry(fHF, new TGTextBuffer(24));
  fName->Resize(120, fName->GetDefaultHeight());
  fName->SetText( gDataFilePath.c_str() );
  fEnter = new TGTextButton(fHF, " set ", ENTER);
  fEnter->Associate(this);
  fEnter->ChangeBackground(colorred);
  fHF->AddFrame(fName,fLayout);
  fHF->AddFrame(fEnter,fLayout);

  fHF2 = new TGHorizontalFrame(fGF1,100,230,kChildFrame,fgDefaultFrameBackground);
  fHF2->ChangeBackground(colordefault);

  fExplain = new TGTextView(fHF2,10,10,"");
  fExplain->Resize(120, fExplain->GetDefaultHeight());
  fExplain->AddLine("The Data File Path is the place");
  fExplain->AddLine("where you stored the auger data.");
  fExplain->AddLine("From this directory, the data should be in");
  fExplain->AddLine(" =>    YYYY/MM/<prefix>_YYYY_MM_DD_HHhMM.root");
  fExplain->AddLine("");
  fExplain->AddLine("Example: if your typical data file looks like");
  fExplain->AddLine("/home/auger/auger_data/2004/08/ad_2004_08_09_12h00.root");
  fExplain->AddLine("the path here would be /home/auger/auger_data/");
  fExplain->AddLine("");
  fExplain->AddLine("");
  fExplain->AddLine("We recommend the use of the path to the ad_*.root files");
  fExplain->AddLine("Select 'Save configuration' in the Configure menu to");
  fExplain->AddLine("keep this data file path for future uses of ED");
  fExplain->AddLine("");
  fHF2->AddFrame(fExplain,fMaxY);

  fGF1->AddFrame(fHF,fMax);
  fGF1->AddFrame(fHF2,fMaxY);

  AddFrame(fGF1,fMaxY);
  MapSubwindows();
  Layout();

  if (main) {
    int ax, ay;
    Window_t wdummy;
    gVirtualX->TranslateCoordinates(main->GetId(), GetParent()->GetId(),
                                    (Int_t)(((TGFrame *) main)->GetWidth() - GetWidth()) >> 1,
                                    (Int_t)(((TGFrame *) main)->GetHeight() - GetHeight()) >> 1,
                                    ax, ay, wdummy);
    if (ax < 0)
      ax = 10;
    if (ay < 0)
      ay = 10;
    Move(ax, ay);
    SetWMPosition(ax, ay);
  }

  ChangeBackground(colordefault);
  SetWindowName("Data File Path Selection");
  SetIconName("t. n.");
  MapWindow();
}

Bool_t EDDataFilePath::ProcessMessage(Long_t msg, Long_t parm1, Long_t) {
  DIR *tmp;
  switch (GET_MSG(msg)) {
  case kC_COMMAND:
    switch (GET_SUBMSG(msg)) {
    case kCM_BUTTON:
      if(parm1==ENTER) {
        tmp=opendir(fName->GetBuffer()->GetString());
        if (tmp) {
          closedir(tmp);
          gDataFilePath = fName->GetBuffer()->GetString();
          CloseWindow();
        } else {
          fExplain->AddLine("");
          fExplain->AddLine("Invalid directory...");
        }
        break;
      }
    default:
      break;
    }
  default:
    break;
  }
  return kTRUE;
}
