#include "EDDoc.h"

/*-----------------------------------------------------------------------------*/
EDDoc::EDDoc(const TGWindow *p, UInt_t w, UInt_t h) : TGTab(p, w, h) {
  /*-----------------------------------------------------------------------------*/
  std::string picture1=strdup(EDSRCDIR)+(std::string)"/Auger_logo.xpm";
  TGPicture *fPicture1 = (TGPicture *)gClient->GetPicture(picture1.c_str());
  TText *t;
  TRootEmbeddedCanvas*trec;

  /////// Colors

  // Defining colours
  ULong_t colourdefault;
  ULong_t colourmenu,colourtab1,colourtabelem1;
  gClient->GetColorByName("AntiqueWhite3",colourdefault);
  gClient->GetColorByName("AntiqueWhite3",colourtab1);
  gClient->GetColorByName("bisque3",colourtabelem1);
  gClient->GetColorByName("azure2",colourmenu);
  this->ChangeBackground(colourdefault);

  /////// Tab about us.
  TGCompositeFrame *tf=this->AddTab("About");
  tf->ChangeBackground(colourdefault);
  TGLayoutHints *fMax = new TGLayoutHints(kLHintsTop | kLHintsExpandX | kLHintsExpandY, 1, 1, 1, 0);


  trec=new TRootEmbeddedCanvas("AboutCanvas",tf,100,100);
  TGIcon *Icon3 = new TGIcon(tf,fPicture1,fPicture1->GetWidth(),fPicture1->GetHeight());
  trec->AddFrame(Icon3,new TGLayoutHints(kLHintsTop | kLHintsRight,1,1,4,1));
  tf->AddFrame(trec,fMax);
  trec->GetCanvas()->cd();
  trec->GetCanvas()->Range(0,0,1,1);
  t=new TText(0.5,0.87,"CDAS Sd Event Display");
  t->SetTextAlign(21);
  t->SetTextFont(32);
  t->SetTextSize(0.06);
  t->Draw();
  t=new TText(0.5,0.85,VERSION);
  t->SetTextAlign(23);
  t->SetTextSize(0.03);
  t->Draw();
  t=new TText(0.5,0.71,"http://www.auger.org.ar/CDAS/ED/");
  t->SetTextAlign(22);
  t->SetTextSize(0.03);
  t->Draw();
  t=new TText(0.5,0.55,"Authors: CDAS team");
  t->SetTextAlign(22);
  t->SetTextSize(0.04);
  t->SetTextFont(32);
  t->Draw();
  t=new TText(0.33,0.45,"Main developers:");
  t->SetTextAlign(31);
  t->SetTextSize(0.03);
  t->Draw();
  t=new TText(0.35,0.45,"Pierre Da Silva (pdasilva@lpnhep.in2p3.fr)");
  t->SetTextAlign(11);
  t->SetTextSize(0.03);
  t->Draw();
  t=new TText(0.35,0.40,"Xavier Bertou (bertou@auger.org.ar)");
  t->SetTextAlign(11);
  t->SetTextSize(0.03);
  t->Draw();
  t=new TText(0.35,0.35,"Pierre Billoir (billoir@in2p3.fr)");
  t->SetTextAlign(11);
  t->SetTextSize(0.03);
  t->Draw();
  t=new TText(0.5,0.25,"Contributions:");
  t->SetTextAlign(22);
  t->SetTextSize(0.03);
  t->Draw();	
  t=new TText(0.5,0.20,"Sky map by Yamamoto Tokonatsu (yamamoto@oddjob.uchicago.edu)");
  t->SetTextAlign(22);
  t->SetTextSize(0.03);
  t->Draw();
  t=new TText(0.5,0.15,"Hybrid 3D representation by Martina Bohacova (bohacova@fzu.cz)");
  t->SetTextAlign(22);
  t->SetTextSize(0.03);
  t->Draw();
  t=new TText(0.5,0.05,"Please report any bug (or feature request) on the Auger bugzilla server at http://bugzilla.auger.org.ar/");
  t->SetTextAlign(22);
  t->SetTextSize(0.02);
  t->Draw();
  trec->GetCanvas()->SetEditable(kFALSE);

  /////// Tab with text information
  tf=this->AddTab("Generic help");
  tf->ChangeBackground(colourdefault);
  TGTextView *fTextInfo=new TGTextView(tf,10,10,"");
  tf->AddFrame(fTextInfo,fMax);
  std::string tit=((std::string)"Welcome to the CDAS Event Display, ")+((std::string)VERSION);
  fTextInfo->AddLine(tit.c_str());
  std::string s="";
  unsigned int size = tit.size();
  for (unsigned int i=0;i<size;i++)
    s+=(std::string)"=";
  fTextInfo->AddLine(s.c_str());
  fTextInfo->AddLine("");
  fTextInfo->AddLine("ED has been developped by the CDAS group to visualize events of the ground array. Its use should be straightforward.");
  fTextInfo->AddLine("The main screen contains a Control subwindow and 3 vizualisation windows, one for the Array, one for the FADC traces and");
  fTextInfo->AddLine("reconstruction information, and a Status box giving generic informations. Some more low level informations are printed in");
  fTextInfo->AddLine("the terminal from which the ED has been launched. This help describes v4r0 version. v4r2 is very similar.");
  fTextInfo->AddLine("");
  fTextInfo->AddLine("o The control pannel has a menu offering the following possibilities:");
  fTextInfo->AddLine("    File:");
  fTextInfo->AddLine("          Change Data File Path       will allow you to change the base directory for data, see below");
  fTextInfo->AddLine("          Load...                     will open a new window for you to select a specific data file to load");
  fTextInfo->AddLine("          Current file                will open the latest file available");
  fTextInfo->AddLine("          Last file                   will open the previous one");
  fTextInfo->AddLine("          Last 24h/48h/week/month     are explicit");
  fTextInfo->AddLine("          Select period               will open a new window to select any period of time. Some edge effects are expected");
  fTextInfo->AddLine("    Configure:");
  fTextInfo->AddLine("          All-in-one display          displays all the stations of the selected event with the 3 phototubes superposed");
  fTextInfo->AddLine("          Shower plane projection     the array is now represented in the shower plane. The red line indicates the north, and four");
  fTextInfo->AddLine("                                      contour levels are represented at 100, 10, 4 (T2) and 2 (T1) VEM");
  fTextInfo->AddLine("          3D animated reconstruction  shows a nice 3D simulation of the event");
  fTextInfo->AddLine("          Save 3D animation           saves in Anim.gif the event 3D animation");

  //about reconstruction
  fTextInfo->AddLine("          Event and Station Select.   governs how casual stations are detected and removed");
  fTextInfo->AddLine("                Official Selection    Selects T4 events and apply a bottom-up algorithm to remove casuals");
  fTextInfo->AddLine("                Off. Selection + T5   As above + T5 criteria applied");
  fTextInfo->AddLine("                Apply before counting the number of stations asked for will be after casual rejection and not before");
  fTextInfo->AddLine("                                      This takes time but guarantees you have \"n\" real tanks or more in your event");
  fTextInfo->AddLine("                Apply upon clicking.  the casual algorithm is applied when you select an event.");
  fTextInfo->AddLine("                                      We recommend using that option as well as the Bottom Up algorithm");
  fTextInfo->AddLine("          Horizontal options          draw ground pattern matching, or likelihood function as function of shower core");
  fTextInfo->AddLine("                                      for fixed or fitted energy");
  fTextInfo->AddLine("          Single reconstructions      selects one particular reconstruction");
  fTextInfo->AddLine("                All parameters fit    activates one global reconstruction where the search for the best configuration of ");
  fTextInfo->AddLine("                                      stations is not performed (what is done by default)");
  fTextInfo->AddLine("                Plane + LDF fits      activates a two steps reconstruction with the assumption of a plane shower front");
  fTextInfo->AddLine("                Curve + LDF fits      activates a two steps reconstruction with the assumption of a curved shower front");
  fTextInfo->AddLine("                Impose core from...   For stereo hybrid events, the core can be imposed by Fd");
  fTextInfo->AddLine("                Variable slope LDF    activates a global E/Xmax fit. Xmax is still preliminary");
  fTextInfo->AddLine("                Correct Asymmetries   takes into account divergence from cylindrical symmetry");
  fTextInfo->AddLine("                Force reconstruction  forces the reconstruction, even if stations time residues are great and/or in case ");
  fTextInfo->AddLine("                                      of \"nan\" values");
  fTextInfo->AddLine("                Do not use silent.    removes the \"silent\" stations from the energy and core position fit");

  fTextInfo->AddLine("          Select events only          selects only events passing reconstruction");
  fTextInfo->AddLine("                                      use a proper casual rejection else it makes no sense");
  fTextInfo->AddLine("          Show sky map                when doing a reconstruction, a map showing the arrival directions in ");
  fTextInfo->AddLine("                                      galactic coordinates is displayed");
  fTextInfo->AddLine("          3D sky map                  toggles 3D mode of the sky map, in which the blue line is at l=0, the red at b=0, 0<l<180");
  fTextInfo->AddLine("          Show number of stat/event   alters the display of the two lists to help knowing number of events and stations selected");
  fTextInfo->AddLine("          Show station name           to display station names instead of CPU Id");
  fTextInfo->AddLine("          Show start of trigger       will indicate where is the time of the trigger compared to the start of the signal (t0)");
  fTextInfo->AddLine("          Save configuration          saves the options selected as the new defaults");

  fTextInfo->AddLine("    Experts only...:");
  fTextInfo->AddLine("          Modify event...             will open a new window in which you can modify various parameters, see below");
  fTextInfo->AddLine("          Show all stations           also shows in the station list stations without data");
  fTextInfo->AddLine("          Show 6 FADC                 shows the 6 FADC raw data and not the 3 calibrated phototubes");
  fTextInfo->AddLine("          Show raw calibration        doesn't show traces but gives all raw calibration information of the selected station");
  fTextInfo->AddLine("          Show raw histograms         shows the baseline, peak, charge and shape pulse histograms of the selected station");
  fTextInfo->AddLine("          Accidental suppression      governs how casual stations are detected and removed in more details");
  fTextInfo->AddLine("                T4 criteria           Selects T4, without Bottom Up algorithm applied");
  fTextInfo->AddLine("                T5 criteria           Selects T5, without T4 / Bottom Up algorithm applied");
  fTextInfo->AddLine("                Remove ...            Calls specific Es algorithm");
  fTextInfo->AddLine("          Select trigger              to have only a subset of events depending on the T3 trigger type");
  fTextInfo->AddLine("                                      See Ct (Central trigger) documentation for the explanation of the triggers");

  fTextInfo->AddLine("");
  fTextInfo->AddLine("Once a file has been selected, all events with more than 8 stations triggered will be considered.");
  fTextInfo->AddLine("To change this threshold, just modify the value '8' in the text window next to the Update button.");
  fTextInfo->AddLine("You can then select a new file, set of files, or click on Update to apply this new threshold to your previous selection.");
  fTextInfo->AddLine("Then, all events with this number of stations will be displayed in default mode. If 'Select events only' is activated, only");
  fTextInfo->AddLine("events passing reconstruction will be displayed, with their energy, zenith angle, and number of triggered stations.");
  fTextInfo->AddLine("");
  fTextInfo->AddLine("o The Get # button will look for a specific event number, as entered in the nearby text window. It needs a database of the event files");
  fTextInfo->AddLine("  you have and their location. It will automatically build it and update it upon request. Please be patient in this operation.");
  fTextInfo->AddLine("");
  fTextInfo->AddLine("o The Previous and Next buttons allow you to browse the events, and the Reconstruct will operate the reconstruction, with the options");
  fTextInfo->AddLine("  selected from the Experts only menu.");
  fTextInfo->AddLine("");
  fTextInfo->AddLine("o The Modify event menu allow you to modify the real data. You can remove an obviously bad PMT, change the starting time of the signal");
  fTextInfo->AddLine("  in a station if the start of trace algorithm was deceived by what looks like noice, etc.");
  fTextInfo->AddLine("  The modifications will apply to the selected station. If you remove a PMT, the average signal will be recomputed. In order to take");
  fTextInfo->AddLine("  into account a modification in the average signal, you have to press the 'Apply' button. The 'Done' button will close the window.");
  fTextInfo->AddLine("  The 'Delete station' will remove the station from the event (it will be considered off at the time of the event).");
  fTextInfo->AddLine("  To reset the event to its unmodified state, just click on it again in the event list.");
  fTextInfo->AddLine("");
  fTextInfo->AddLine("");
  fTextInfo->AddLine("Remarks: in order for ED to work properly (find events by number, browse months of data, and so on), the CDAS file hierarchy");
  fTextInfo->AddLine("must be followed. You therefore need to have your data in the following format:");
  fTextInfo->AddLine("  /some_directory_of_your_choice/2003/");
  fTextInfo->AddLine("  /some_directory_of_your_choice/2004/");
  fTextInfo->AddLine("  /some_directory_of_your_choice/2004/01/");
  fTextInfo->AddLine("  /some_directory_of_your_choice/2004/02/");
  fTextInfo->AddLine("  /some_directory_of_your_choice/2004/03/");
  fTextInfo->AddLine("  /some_directory_of_your_choice/2004/03/ad_2002_03_25_09h29.root");
  fTextInfo->AddLine("");
  fTextInfo->AddLine("This /some_directory_of_your_choice/ has to be entered as the data file path in the 'File' menu");

  /////// Tab with what's new
#include "EDDocChanges.h"

  /////// Tab with station color code
  tf=this->AddTab("Station Color Code");
  tf->ChangeBackground(colourdefault);
  trec=new TRootEmbeddedCanvas("StationColorCanvas",tf,500,500);
  tf->AddFrame(trec,fMax);
  trec->GetCanvas()->cd();
  t=new TText(0.15,0.90,"Station Color Code");
  t->Draw();
  int nb=10;
  float dt=0.70/nb;
  float base=0.82;
  TEllipse *e=new TEllipse(0.1,base-0*dt,0.03,0.03,0,360,0);
  t=new TText(0.2,base-0*dt,"Station in T3");
  e->SetFillColor(3);
  t->SetTextAlign(12);
  e->Draw();
  t->Draw();
  e=new TEllipse(0.1,base-1*dt,0.03,0.03,0,360,0);
  t=new TText(0.2,base-1*dt,"Additional station with signal");
  e->SetFillColor(5);
  t->SetTextAlign(12);
  e->Draw();
  t->Draw();
  e=new TEllipse(0.1,base-2*dt,0.03,0.03,0,360,0);
  t=new TText(0.2,base-2*dt,"Station without data");
  e->SetFillColor(38);
  t->SetTextAlign(12);
  e->Draw();
  t->Draw();
  e=new TEllipse(0.1,base-3*dt,0.03,0.03,0,360,0);
  t=new TText(0.2,base-3*dt,"Station with lightning data");
  e->SetFillColor(94);
  t->SetTextAlign(12);
  e->Draw();
  t->Draw();
  e=new TEllipse(0.1,base-4*dt,0.03,0.03,0,360,0);
  t=new TText(0.2,base-4*dt,"Data lost on its way to storage");
  e->SetFillColor(46);
  t->SetTextAlign(12);
  e->Draw();
  t->Draw();
  e=new TEllipse(0.1,base-5*dt,0.03,0.03,0,360,0);
  t=new TText(0.2,base-5*dt,"Station down");
  e->SetFillColor(1);
  t->SetTextAlign(12);
  e->Draw();
  t->Draw();
  e=new TEllipse(0.1,base-6*dt,0.03,0.03,0,360,0);
  t=new TText(0.2,base-6*dt,"T3 lost by local station");
  e->SetFillColor(2);
  t->SetTextAlign(12);
  e->Draw();
  t->Draw();
  e=new TEllipse(0.1,base-7*dt,0.03,0.03,0,360,0);
  t=new TText(0.2,base-7*dt,"Station not in acquisition");
  e->SetFillColor(10);
  t->SetTextAlign(12);
  e->Draw();
  t->Draw();
  e=new TEllipse(0.1,base-8*dt,0.03,0.03,0,360,0);
  t=new TText(0.2,base-8*dt,"Ambiguous Station");
  e->SetFillColor(23);
  t->SetTextAlign(12);
  e->Draw();
  t->Draw();
  e=new TEllipse(0.1,base-9*dt,0.03,0.03,0,360,0);
  t=new TText(0.2,base-9*dt,"Station deleted");
  e->SetFillColor(10);
  t->SetTextAlign(12);
  e->Draw();
  t->Draw();
  TLine *line1 = new TLine();
  TLine *line2 = new TLine();
  float offset = 0.03;
  float x = 0.1;
  float y = base-9*dt;
  line1->SetX1(x-offset);
  line1->SetX2(x+offset);
  line1->SetY1(y-offset);
  line1->SetY2(y+offset);
  line2->SetX1(x+offset);
  line2->SetX2(x-offset);
  line2->SetY1(y-offset);
  line2->SetY2(y+offset);
  line1->SetLineColor(6);
  line1->SetLineWidth(3);
  line1->Draw();
  line2->SetLineColor(6);
  line2->SetLineWidth(3);
  line2->Draw();
  e=new TEllipse(0.1,base-10*dt,0.03,0.03,0,360,0);
  t=new TText(0.2,base-10*dt,"Silent station");
  e->SetFillColor(7);
  t->SetTextAlign(12);
  e->Draw();
  t->Draw();
  trec->GetCanvas()->SetEditable(kFALSE);

  for (int i=0;i<4;i++)
    this->GetTabTab(i)->ChangeBackground(colourdefault);
  this->Resize(this->GetDefaultSize());
}
/*-----------------------------------------------------------------------------*/
