#ifndef EDEXPERT_H
#define EDEXPERT_H

#include <TGClient.h>
#include <TGButton.h>
#include "EDMainFrame.h"

class EDMainFrame;

class EDExpertFrame : public TGTransientFrame {

private:
  TGHorizontalFrame *fHF, *fHF2 ;
  TGTextButton    *fDelPmt[3],*fApply,*fCancel,*fDelStation,*fEarly,*fLate,*fVEarly,*fVLate;
  TGTextEntry     *fPmt[3],*fSig;
  TGLabel *fPmtL[3],*fStartTimeL,*fSigL;
  TGLayoutHints   *fLayout, *fMax, *fCMax ;
  TGGroupFrame *fGF1;

  TErEvent *fEvent;// do not delete
  EDMainFrame *fMain;// do not delete
  TCalibStation *fStation;// do not delete

public:

  EDExpertFrame (const TGWindow *, const TGWindow *, UInt_t w, UInt_t h);
  ~EDExpertFrame () {
    delete fHF;
    delete fHF2;
    delete fGF1;
    delete fCMax;
    delete fMax;
    delete fLayout;
    delete fSigL;
    delete fStartTimeL;
    delete fPmtL[0];
    delete fPmtL[1];
    delete fPmtL[2];
    delete fPmt[0];
    delete fPmt[1];
    delete fPmt[2];
    delete fSig;
    delete fVLate;
    delete fVEarly;
    delete fLate;
    delete fEarly;
    delete fDelStation;
    delete fCancel;
    delete fApply;
    delete fDelPmt[0];
    delete fDelPmt[1];
    delete fDelPmt[2];
  }
  Bool_t ProcessMessage (Long_t msg, Long_t parm1, Long_t parm2);
  void CloseWindow () {
    delete this;
  }
  //void DoCancel() {SendCloseMessage();} //
};

#endif
