#ifndef EDEYE_H
#define EDEYE_H

#include <list>
#include <string>
#include <iostream>
#include <iomanip>

#include <TGFrame.h>
#include <TGButton.h>
#include <TGTab.h>
#include <TRootEmbeddedCanvas.h>
#include <TCanvas.h>
#include <TEllipse.h>
#include <TGSlider.h>
#include <TGraph.h>
#include <TH1F.h>
//#include <TF2.h>

#include "IoAuger.h"
#include "TShowerParams.h"

// Colors
class FDPixelCanvas : public TRootEmbeddedCanvas {
private:
public:
  int fColor;
  TH1F  *PixelData[10];
  TCanvas *fCanvas;
  FDPixelCanvas(const char *name, const TGWindow *p, const TGWindow *main, unsigned int w, unsigned int h, unsigned int options=kSunkenFrame|kDoubleBorder, unsigned long back=fgDefaultFrameBackground);
  ~FDPixelCanvas() {
    for (int i = 0; i!=10; ++i)
      if (PixelData[i])
        delete PixelData[i];
  };
  void cd() {
    fCanvas->cd();
  }

};

class EDEyeEmbeddedCanvas : public TRootEmbeddedCanvas {
private:
  TEyeEvent               *fEvent;
  TCanvas                 *fCanvasEye;
  int                     fEye;
  double                  fRot;
  TEllipse                *fPixel[FdUtil::Fd::kEYE_NEXTPIXELS+1];
  TGraph                  *fSDP;
  //TF2                     *fSDP2;
public:
  FDPixelCanvas           *fFDPixelCanvas;
  EDEyeEmbeddedCanvas(const char *name,const TGWindow* p,int x,int y,int eye,double rotation=0.,double size=0.1);
  ~EDEyeEmbeddedCanvas() {
    for (unsigned int i=0;i<FdUtil::Fd::kEYE_NEXTPIXELS;i++)
      if (fPixel[i])
        delete fPixel[i];
  }
  int fRange,fMultiview;
  void Update();
  void SetView(double);
  void SetFullView();
  void SetSDP(double,double,double);
  int DrawEye(TEyeEvent *ev);
  int DrawShower(TShowerParams *sp);
  TEllipse *NewPixel(int);
  bool HandleButton(Event_t *);
  void SetPixelCanvas(FDPixelCanvas *c) { fFDPixelCanvas=c;};
  //void NewSDP();

  double                  fXmin;
  double                  fYmin;
  double                  fYmax;
  double                  fView;
};

class EDEyeCanvas : public TGVerticalFrame {
private:
  TGHSlider               *fSlide;
  TGHorizontalFrame       *fControl;
  EDEyeEmbeddedCanvas     *fEDEyeEmbeddedCanvas;
  FDPixelCanvas           *fFDPixelCanvas;
  TGCheckButton           *fPixelFullRange,*fMultiviewButton;
  int                     fEye;
  int                     fSliding;
  Bool_t                  ProcessMessage(long, long, long);
  TGTab                   *fTab;
  ULong_t                 fColorNone;
  ULong_t                 fColorData;

public:
  EDEyeCanvas(const TGWindow *p,int eye,TGTab *p2);
  int DrawEye(TEyeEvent *ev);
  int DrawShower(TShowerParams *sp) {
    return fEDEyeEmbeddedCanvas->DrawShower(sp);
  }
  void ChangeColor(ULong_t color);
  void SetView(double i) {
    fEDEyeEmbeddedCanvas->SetView(i);
  }
  void Update() {
    fEDEyeEmbeddedCanvas->Update();
  }
};

#endif
