#ifndef EDHYBRID_H
#define EDHYBRID_H

/*
#ifndef N_PIX_TOT
  #define N_PIX_TOT 440 // tubes in camera
#endif
#ifndef N_CAM
  #define N_CAM   6
#endif
*/

#include "FD.h"

#include "TSPHE.h"
#include "TTUBS.h"
#include "TF2.h"
#include "TPad.h"
#include "TPolyMarker3D.h"

class TEDHybrid {
private:
  TPad *Pad;
  // Temporary affected values
  int X3D;
  SdEvent *Event;
  // Camera orientation
  struct pixpoint cam[N_CAM+1][N_PIX_TOT+1];
  int ReadCam();
  // 3D objects
  TTUBS *LL,*COI;
  TSPHE *xbay4LL,*xbay5LL,*bay4LL,*bay5LL;
  TTUBE *LLseg,*COIseg;
  TSPHE *Shower,*CameraPixel,*ImpactPoint;
  TTUBE *Sdon,*Sdoff,*Sdbug,*Sdt1,*Sdt2,*SdN;
  TF2 *empty,*Sdp;
  TPolyMarker3D *ShowerPoints,*HitTanks,*OffTanks;
  TPolyLine3D *SDLine;
  TPolyMarker3D *SDCore;
  // Event and Reconstuction
  double Ri[N_PIX_TOT], vx[N_PIX_TOT], vy[N_PIX_TOT], vz[N_PIX_TOT];
  int NPixEvent,NPixFinal;
  int Bay;
  double ImpX,ImpY,ImpZ;  // Impact point
  MujPixel ** PixArray;
  // Functions
  int FindEvent();
  int Reconstruct();
  // Drawing
  int InitPad();
  int InitX3D();
  int InitN3D();
  int DrawTanks();
  int DrawShower();
public:
  TEDHybrid();
  ~TEDHybrid() {}
  ;
  int Draw(SdEvent *event,int x3d);
};

#endif
