#include "EDTrigger.h"
#include <sstream>

enum MessageId {
  ENTER
};

EDTrigger::EDTrigger(const TGWindow *p,const TGWindow *main, UInt_t w, UInt_t h) : TGTransientFrame(p, main, w, h) {

  if(main) fMain = (EDMainFrame *)main;
  else return;

  unsigned long colordefault, colorred;
  gClient->GetColorByName("AntiqueWhite3",colordefault);
  gClient->GetColorByName("IndianRed1",colorred);

  fGF1 = new TGGroupFrame(this, "Enter trigger name", kVerticalFrame);
  fGF1->ChangeBackground(colordefault);
  fHF = new TGHorizontalFrame(fGF1,100,30,kChildFrame,fgDefaultFrameBackground);
  fHF->ChangeBackground(colordefault);
  fHF->SetLayoutManager(new TGMatrixLayout(fHF,0,2,5,5));

  fMax = new TGLayoutHints(kLHintsExpandX);//| kLHintsExpandY);
  fLayout = new TGLayoutHints(kLHintsExpandX | kLHintsCenterX | kLHintsCenterY);

  fName = new TGTextEntry(fHF, new TGTextBuffer(24));
  fName->Resize(120, fName->GetDefaultHeight());
  fName->SetText("all");
  fEnter = new TGTextButton(fHF, " enter ", ENTER);
  fEnter->Associate(this);
  fEnter->ChangeBackground(colorred);
  fHF->AddFrame(fName,fLayout);
  fHF->AddFrame(fEnter,fLayout);

  fGF1->AddFrame(fHF,fMax);
  AddFrame(fGF1,fMax);
  MapSubwindows();
  Layout();

  if (main) {
    int ax, ay;
    Window_t wdummy;
    gVirtualX->TranslateCoordinates
      (main->GetId(), GetParent()->GetId(),
       (Int_t)(((TGFrame *) main)->GetWidth() - GetWidth()) >> 1,
       (Int_t)(((TGFrame *) main)->GetHeight() - GetHeight()) >> 1,
       ax, ay, wdummy);
    if (ax < 0) ax = 10;
    if (ay < 0) ay = 10;
    Move(ax, ay);
    SetWMPosition(ax, ay);
  }
  
  ChangeBackground(colordefault);
  SetWindowName("Trigger");
  SetIconName("t. n.");
  MapWindow();
}

bool EDTrigger::ProcessMessage(long msg, long parm1, long) {
  switch (GET_MSG(msg)) {
  case kC_COMMAND:
    switch (GET_SUBMSG(msg)) {
    case kCM_BUTTON:
      if(parm1==ENTER) {
        fMain->fTriggerName = fName->GetBuffer()->GetString();
        CloseWindow();
        break;
      }
    default:
      break;
    }
  default:
    break;
  }
  return kTRUE;
}

/********************* EDSelectStation Class *********************/
EDSelectStation::EDSelectStation(const TGWindow *p,const TGWindow *main, UInt_t w, UInt_t h) : TGTransientFrame(p, main, w, h) {

  if(main) fMain = (EDMainFrame *)main;
  else return;

  unsigned long colordefault, colorred;
  gClient->GetColorByName("AntiqueWhite3",colordefault);
  gClient->GetColorByName("IndianRed1",colorred);

  fGF1 = new TGGroupFrame(this, "Enter station name", kVerticalFrame);
  fGF1->ChangeBackground(colordefault);
  fHF = new TGHorizontalFrame(fGF1,100,30,kChildFrame,fgDefaultFrameBackground);
  fHF->ChangeBackground(colordefault);
  fHF->SetLayoutManager(new TGMatrixLayout(fHF,0,2,5,5));

  fMax = new TGLayoutHints(kLHintsExpandX);
  fLayout = new TGLayoutHints(kLHintsExpandX | kLHintsCenterX | kLHintsCenterY);

  fName = new TGTextEntry(fHF, new TGTextBuffer(48));
  fName->Resize(150, fName->GetDefaultHeight());
  fName->SetText("All stations");
  fEnter = new TGTextButton(fHF, " Enter ", ENTER);
  fEnter->Associate(this);
  fEnter->ChangeBackground(colorred);
  fHF->AddFrame(fName,fLayout);
  fHF->AddFrame(fEnter,fLayout);

  fGF1->AddFrame(fHF,fMax);
  AddFrame(fGF1,fMax);
  MapSubwindows();
  Layout();

  if (main) {
    int ax, ay;
    Window_t wdummy;
    gVirtualX->TranslateCoordinates
      (main->GetId(), GetParent()->GetId(),
       (Int_t)(((TGFrame *) main)->GetWidth() - GetWidth()) >> 1,
       (Int_t)(((TGFrame *) main)->GetHeight() - GetHeight()) >> 1,
       ax, ay, wdummy);
    if (ax < 0) ax = 10;
    if (ay < 0) ay = 10;
    Move(ax, ay);
    SetWMPosition(ax, ay);
  }

  ChangeBackground(colordefault);
  SetWindowName("Select Station");
  SetIconName("Sel.");
  MapWindow();
}

bool EDSelectStation::ProcessMessage(long msg, long parm1, long) {
  switch (GET_MSG(msg)) {
  case kC_COMMAND:
    switch (GET_SUBMSG(msg)) {
    case kCM_BUTTON:
      if(parm1==ENTER) {
        fMain->fStationName = fName->GetBuffer()->GetString();
        CloseWindow();
        break;
      }
    default:
      break;
    }
  default:
    break;
  }
  return kTRUE;
}
