#ifndef ED__FILES_H
#define ED__FILES_H

#include <vector>
#include <string>
#include <EDMainFrame.h>

#include <TGClient.h>
#include <TGButton.h>
#include <TGComboBox.h>


class RFile {
public:
  RFile(const char* name="" );

  bool operator  <(const RFile&) const;
  bool operator <=(const RFile&) const;
  bool operator  >(const RFile&) const;
  bool operator >=(const RFile&) const;
  bool operator ==(const RFile&) const;
  bool operator !=(const RFile&) const;

  const char* filename();

  std::string fileName;
  time_t seconds;
};

class EDFileSelect : public TGTransientFrame {
private:
  vector<RFile> *tofill;
  int *fhaschanged;

  TGLayoutHints *fLayout;
  TGLayoutHints *fMax;
  TGCompositeFrame *fGF1;
  TGComboBox *fYear1;
  TGComboBox *fMonth1;
  TGComboBox *fDay1;
  TGCompositeFrame *fGF2;
  TGComboBox *fYear2;
  TGComboBox *fMonth2;
  TGComboBox *fDay2;
  TGTextButton *fButton1;
  TGTextButton *fButton2;

public:
  EDFileSelect(const TGWindow *, const TGWindow *, UInt_t w, UInt_t h, vector<RFile>&rootfiles,int *haschanged);
  ~EDFileSelect() {
    delete fLayout;
    delete fMax;
    delete fGF1;
    delete fYear1;
    delete fMonth1;
    delete fDay1;
    delete fGF2;
    delete fYear2;
    delete fMonth2;
    delete fDay2;
    delete fButton1;
    delete fButton2;
  }

  Bool_t ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2);
  void CloseWindow() {
    delete this;
  }
};

int BuildAllRootFiles();
int BuildAllRootFiles(string);
void SelectFiles(vector<RFile>&,int);

extern vector<RFile> gAllRootFiles;

const char *GetFileName(unsigned long long, const char *);
#endif
