#ifdef FD
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <dirent.h>
#include "FD.h"
#include <MiEvent.hh>
#include <MiEventFile.hh>
#include "FDPixel.h"

#ifndef DATAFILEPATH
#define DATAFILEPATH "/Raid/data/Sd/"
#endif

// -------------------------------------------------------------------------
int CanBeInFile(char *File,int GPStime) {

  TMirrorEventFile *file = new TMirrorEventFile(File);
  if (!file->GetNEvents())
    return 0;

  TMirrorRunHeader *header = new TMirrorRunHeader;
  TMirrorRunTrailer *trailer = new TMirrorRunTrailer;

  int UTCtime=GPStime+ 315964800-13;
  int rv=0;

  if ( file->ReadRunTrailer( &trailer ) ) {
    if ((UTCtime+5>(trailer->StartTime())) && (UTCtime< (trailer->StopTime()+5)))
      rv=1;
  }

  delete header;
  delete trailer;
  delete file;
  return rv;
}

// -------------------------------------------------------------------------
int GetSeek(char *File,unsigned int GPStime,unsigned int Nanotime) {
  TMirrorEventFile *file = new TMirrorEventFile( File);
  TMirrorRunHeader *header = new TMirrorRunHeader;
  TMirrorRunTrailer *trailer = new TMirrorRunTrailer;
  TMirrorEvent *event = new TMirrorEvent();
  int Seek=0,rv=-1,add
                =0;

  /* Try to have a fast algorithm */
  if ( file->ReadRunTrailer( &trailer ) ) {
    // Guess a starting point, proportional
    Seek=(int)(file->GetNEvents()*(GPStime+315964800-13-trailer->StartTime())*1./(trailer->StopTime()-trailer->StartTime()));
    if (Seek>=(int)file->GetNEvents())
      Seek=file->GetNEvents()-1;
    file->Seek(Seek);
    file->ReadMirrorEvent( &event );
    if (GPStime==event->EventHeader()->GPSTime()) {
      cout << "FOUND event #"<<Seek<<" with same GPSTime and " << event->EventHeader()->GPSNanoTime() - Nanotime << " ns of time difference" <<endl;
      if (abs((int)event->EventHeader()->GPSNanoTime() - (int)Nanotime)<200000) {
        rv=Seek;
      }
    }
    // if not found, get the direction to move in the file
    if (GPStime+Nanotime/1000000000.<event->EventHeader()->GPSTime()+event->EventHeader()->GPSNanoTime()/1000000000.)
      add
        =-1;
    else
      add
        =1;
    // move in that direction...
    Seek+=add
          ;
    file->Seek(Seek);
    while (rv==-1 && event && file->ReadMirrorEvent( &event ) != kFALSE ) {
      if (GPStime==event->EventHeader()->GPSTime()) {
        cout << "FOUND event #"<<Seek<<" with same GPSTime and " << event->EventHeader()->GPSNanoTime() - Nanotime << " ns of time difference" <<endl;
        if (abs((int)event->EventHeader()->GPSNanoTime() - (int)Nanotime)<200000) {
          rv=Seek;
          break;
        }
      }
      // we passed the entry, break!
      if ((((int)GPStime)-(int)(event->EventHeader()->GPSTime()))*add
          <0) break;
      // next try
      Seek+=add
            ;
      file->Seek(Seek);
    }
  }
  /* BASIC algorithm...
     while ( event && file->ReadMirrorEvent( &event ) != kFALSE ) {
     if (GPStime==event->EventHeader()->GPSTime()) {
     cout << "FOUND event #"<<Seek<<" with same GPSTime and " << event->EventHeader()->GPSNanoTime() - Nanotime << " ns of time difference" <<endl;
     if (abs((int)event->EventHeader()->GPSNanoTime() - (int)Nanotime)<200000) {
     rv=Seek;
     break;
     }
     } else if (GPStime<event->EventHeader()->GPSTime()) break;
     Seek++;
     }
  */
  file->Close();
  delete header;
  delete trailer;
  delete file;
  delete event;
  return rv;
}

// -------------------------------------------------------------------------
int GetFile(char *File,int *seek,unsigned int GPSTime,unsigned int NanoTime) {
  DIR *dirp;
  struct dirent *direntp;
  int Seek=-1;
  unsigned int evtime=GPSTime+315964800-13-2*86400;
  for (int i=0;i<3;i++) { // looking in 2 previous days, juust in case
    for (int bay=4;bay<6;bay++) {
      char ddir[512];
      struct tm * sttime=gmtime((const time_t *)&evtime);
      sprintf(ddir,"%s/../Fd/FD-LosLeones/mirrorpc%d/%d/%02d/%02d/data/",DATAFILEPATH,bay,1900+sttime->tm_year,sttime->tm_mon+1,sttime->tm_mday);
      //cout << "Looking in " << ddir << endl;
      if ((dirp=opendir(ddir))) {
        while ((direntp=readdir (dirp))!=NULL) {
          sprintf(File,"%s/%s%c",ddir,direntp->d_name,0);
          if(strstr(File,".root") && CanBeInFile(File,GPSTime)) {
            Seek = GetSeek(File,GPSTime,NanoTime);
            if (Seek>=0)
              break;
          }
        }
      }
      if (Seek>=0)
        break;
    }
    if (Seek>=0)
      break;
    evtime+=86400;
  }
  *seek=Seek;
  return (Seek>=0);
}
#endif
