#ifndef EC_CONSTANTS_H_
#define EC_CONSTANTS_H_

/// Constants for Ec
namespace kEc {
// Constants for calibration purpose
const double SilSigThresh = 3.;   ///< signal threshold for silent station
const double SigThresh    = 0.2;
const double OldThresh    = 0.8;
const int SignalCut    = 3;    ///< with a VEM at 50 currently, we cut at .05 VE
const int StartThresh  = 40;    ///< number of bin
const int FADCDepth  = 768;    ///< FADC depth
const int TimeSlot    = 25;    ///< 25 ns per ADC bin
const int IntegrationWindow  = 250;
  /// Constants to look for anomalies in ADC traces
const int NBIN_LOOK = 300;
const int SHIFT_FROM_BASE = 10;
const int NMAX_UNDERSHOOT = 10;
const int NMAX_CROSS = 6;
  /// Constants for Shape parameters evaluations
const double SHAPE_CUT =  24.0;
const double SHAPE_DIST_REF = 1000.0;
}
#endif
