#include <iostream>
#include <signal.h>
#include "IoAuger.h"
#include "TCdasUtil.h"
#include "SdRecLpnhe.h"
#include "PBRec.h"
#include "TTree.h"

TTree *tr_res;

/*-------------------------------------------------------------------*/
void DefineROOTTrees()
/*-------------------------------------------------------------------*/
{
  tr_res = new TTree("res_tree","events");
  tr_res->Branch("event",&thePBRec().NumEvent,"event/I");
  tr_res->Branch("UTCtime",&thePBRec().UTCTimeEvent,"UTCtime/I");
  tr_res->Branch("Day",&thePBRec().MonitDay,"Day/I");
  tr_res->Branch("Time",&thePBRec().TimeInDay,"Time/I");
  tr_res->Branch("GlTrig",&thePBRec().GlobalTriggerType,"GlTrig/I");
  tr_res->Branch("T4",&thePBRec().T4Flag,"T4/I");
  tr_res->Branch("nStAct",&thePBRec().nActiveStation,"nStAct/I");
  tr_res->Branch("nStWin",&thePBRec().nWindow,"nStWin/I");
  tr_res->Branch("nStSel",&thePBRec().nStationInFit,"nStSel/I");
  tr_res->Branch("flagGeom",&thePBRec().GeomFlag,"flagGeom/I");
  tr_res->Branch("flagLDF",&thePBRec().LDFFlag,"flagLDF/I");
  tr_res->Branch("flagGlob",&thePBRec().GlobFitOK,"flagGlob/I");
  tr_res->Branch("theta",&thePBRec().Theta,"theta/D");
  tr_res->Branch("dtheta",&thePBRec().dTheta,"dtheta/D");
  tr_res->Branch("phi",&thePBRec().Phi,"phi/D");
  tr_res->Branch("dphi",&thePBRec().dPhi,"dphi/D");
  tr_res->Branch("curv",&thePBRec().Curv,"curv/D");
  tr_res->Branch("dcurv",&thePBRec().dCurv,"dcurv/D");
  tr_res->Branch("s1000",&thePBRec().fSRef,"s1000/D");
  tr_res->Branch("ds1000",&thePBRec().dS1000,"ds1000/D");
  tr_res->Branch("energy",&thePBRec().fE,"energy/D");
  tr_res->Branch("denergy",&thePBRec().fdE,"denergy/D");
  tr_res->Branch("xCore",&thePBRec().fXCore,"xCore/D");
  tr_res->Branch("dxCore",&thePBRec().dXCore,"dxCore/D");
  tr_res->Branch("yCore",&thePBRec().fYCore,"yCore/D");
  tr_res->Branch("dyCore",&thePBRec().dYCore,"dyCore/D");
  tr_res->Branch("slopeLDF",&thePBRec().fBeta,"slopeLDF/D");
  tr_res->Branch("chi2Plan",&thePBRec().chi2Plan,"chi2Plan/D");
  tr_res->Branch("chi2Curv",&thePBRec().chi2Curv,"chi2Curv/D");
  tr_res->Branch("chi2LDF",&thePBRec().chi2LDF,"chi2LDF/D");
  tr_res->Branch("chi2Glob",&thePBRec().chi2Glob,"chi2Glob/D");
  tr_res->Branch("rasc",&thePBRec().RightAscension,"rasc/D");
  tr_res->Branch("decl",&thePBRec().Declination,"decl/D");
  tr_res->Branch("gl",&thePBRec().GalacticL,"gl/D");
  tr_res->Branch("gb",&thePBRec().GalacticB,"gb/D");

  tr_res->Branch("st_id",thePBRec().selId,"st_id[nStAct]/I");
  tr_res->Branch("st_mxid",thePBRec().mxId,"st_mxid[nStAct]/I");
  tr_res->Branch("st_trig",thePBRec().LocalTriggerType,"st_trig[nStAct]/I");
  tr_res->Branch("st_anom",thePBRec().Anom,"st_anom[nStAct]/I");
  tr_res->Branch("st_x",thePBRec().X,"st_x[nStAct]/D");
  tr_res->Branch("st_y",thePBRec().Y,"st_y[nStAct]/D");
  tr_res->Branch("st_z",thePBRec().Z,"st_z[nStAct]/D");
  tr_res->Branch("st_t",thePBRec().Tshift,"st_t[nStAct]/D");
  tr_res->Branch("st_sig",thePBRec().Signal,"st_sig[nStAct]/D");
  tr_res->Branch("st_dist",thePBRec().distCore,"st_dist[nStAct]/D");
  tr_res->Branch("st_azim",thePBRec().azimCore,"st_azim[nStAct]/D");
  tr_res->Branch("st_sigfit",thePBRec().sigFit,"st_sigfit[nStAct]/D");
  tr_res->Branch("st_t10",thePBRec().Tfrac10,"st_t10[nStAct]/D");
  tr_res->Branch("st_t50",thePBRec().Tfrac50,"st_t50[nStAct]/D");
  tr_res->Branch("st_t90",thePBRec().Tfrac90,"st_t90[nStAct]/D");
  tr_res->Branch("st_shape",thePBRec().Shape,"st_shape[nStAct]/D");
  tr_res->Branch("st_sat1",thePBRec().Satur1,"st_sat1[nStAct]/I");
  tr_res->Branch("st_sat2",thePBRec().Satur2,"st_sat2[nStAct]/I");
  tr_res->Branch("st_sat3",thePBRec().Satur3,"st_sat3[nStAct]/I");
}


int select_output() {
  return 1;
}

int ReadRequest(char *output_name, char *root_name ) {
  FILE *req;
  char res1_name[100], res2_name[100], res3_name[100],
  aux1_name[100], aux2_name[100], aux3_name[100], aux4_name[100],
  disp_name[100], diag_name[100];
  char item[100], value[100], command[100];
  char line[10000];

  thePBRec().CloseOutputFiles();//because they were opened by the singleton
  system("rm -f `find -size 0`");//to erase empty files

  sprintf(res1_name,"prov1.res");
  sprintf(res2_name,"prov2.res");
  sprintf(res3_name,"prov3.res");
  sprintf(aux1_name,"prov1.aux");
  sprintf(aux2_name,"prov2.aux");
  sprintf(aux3_name,"prov3.aux");
  sprintf(aux4_name,"prov4.aux");
  sprintf(diag_name,"prov.diag");
  sprintf(root_name,"provo.root");
  sprintf(disp_name,"prov.disp");

  req = fopen("../files/Rec.req","r");
  if(!req) printf("!!!! Rec.req   not found on directory '../files' !\n");
  else {
    while (fgets(line,10000,req)) {
      if(sscanf(line,"%s %s",item,value)<2) break;
      if(!strcmp(item,"NevMax")) {
        thePBRec().NevMax = atoi(value); continue;
      }
      if(!strcmp(item,"Simulation")) {
        thePBRec().Simulation = atoi(value); continue;
      }
      if(!strcmp(item,"ReadTruth")) {
        thePBRec().ReadTruth = atoi(value); continue;
      }
      if(!strcmp(item,"Input_sel_evts")) {
        thePBRec().Input_sel_evts = atoi(value); continue;
      }
      if(!strcmp(item,"Write_sel_evts")) {
        thePBRec().Write_sel_evts = atoi(value); continue;
      }
      if(!strcmp(item,"Process_3st")) {
        thePBRec().Process_3st = atoi(value); continue;
      }
      if(!strcmp(item,"Process_gen")) {
        thePBRec().Process_gen = atoi(value); continue;
      }
      if(!strcmp(item,"Reconstruct")) {
        thePBRec().Reconstruct = atoi(value); continue;
      }
      if(!strcmp(item,"FitHoriz")) {
        thePBRec().FitHoriz = atoi(value); continue;
      }
      if(!strcmp(item,"RemoveInfillStation")) {
        thePBRec().RemoveInfillStation = atoi(value); continue;
      }
      if(!strcmp(item,"RemoveDoublet")) {
        thePBRec().RemoveDoublet = atoi(value); continue;
      }
      if(!strcmp(item,"RemoveEA")) {
        thePBRec().RemoveEA = atoi(value); continue;
      }
      if(!strcmp(item,"SelectContained")) {
        thePBRec().SelectContained = atoi(value); continue;
      }
      if(!strcmp(item,"NMIN_AROUND_HIGHEST_SIGNAL")) {
        thePBRec().NMIN_AROUND_HIGHEST_SIGNAL = atoi(value); continue;
      }
      if(!strcmp(item,"CorrectAsym")) {
        thePBRec().CorrectAsym = atoi(value); continue;
      }
      if(!strcmp(item,"PrintLevel")) {
        thePBRec().PrintLevel = atoi(value); continue;
      }
      if(!strcmp(item,"Write1_result")) {
        thePBRec().Write1_result = atoi(value); continue;
      }
      if(!strcmp(item,"Write2_result")) {
        thePBRec().Write2_result = atoi(value); continue;
      }
      if(!strcmp(item,"Write3_result")) {
        thePBRec().Write3_result = atoi(value); continue;
      }
      if(!strcmp(item,"Auxil1_output")) {
        thePBRec().Auxil1_output = atoi(value); continue;
      }
      if(!strcmp(item,"Auxil2_output")) {
        thePBRec().Auxil2_output = atoi(value); continue;
      }
      if(!strcmp(item,"Auxil3_output")) {
        thePBRec().Auxil3_output = atoi(value); continue;
      }
      if(!strcmp(item,"Auxil4_output")) {
        thePBRec().Auxil4_output = atoi(value); continue;
      }
      if(!strcmp(item,"Diagno_output")) {
        thePBRec().Diagno_output = atoi(value); continue;
      }
      if(!strcmp(item,"Display_output")) {
        thePBRec().Display_output = atoi(value); continue;
      }
      if(!strcmp(item,"ROOT_output")) {
        thePBRec().ROOT_output = atoi(value); continue;
      }
      if(!strcmp(item,"List_event")) {
        if(!strcmp(value,"ALL") || !strcmp(value,"0")) thePBRec().List_event = 0;
        else {
          FILE *list_file = fopen(value,"r");
          if(!list_file) printf("!!! event list file  %s  not found !\n",value);
          sprintf(command,"wc -w %s > word.count",value);
          system(command);
          FILE *temp_file = fopen("word.count","r");
          fscanf(temp_file,"%d",&thePBRec().List_event);
          printf(" ------ %d evts on list\n",thePBRec().List_event);
          system("rm word.count");
          fclose(temp_file);
          thePBRec().list_event = (int *)calloc(sizeof(int),thePBRec().List_event);
          for(int i=0; i<thePBRec().List_event; i++) fscanf(list_file,"%d",thePBRec().list_event+i);
          fclose(list_file);
        }
        continue;
      }

      if(!strcmp(item,"HorizModel")) {
        sscanf(value,"%s",thePBRec().HorizModel); continue;
      }
      if(!strcmp(item,"output_name")) {
        sscanf(value,"%s",output_name); continue;
      }
      //if(!strcmp(item,"truth_name")) { sscanf(value,"%s",truth_name); continue; }
      if(!strcmp(item,"truth_root")) {
        thePBRec().truth_root = atoi(value); continue;
      }
      if(!strcmp(item,"res1_name")) {
        sscanf(value,"%s",res1_name); continue;
      }
      if(!strcmp(item,"res2_name")) {
        sscanf(value,"%s",res2_name); continue;
      }
      if(!strcmp(item,"res3_name")) {
        sscanf(value,"%s",res3_name); continue;
      }
      if(!strcmp(item,"aux1_name")) {
        sscanf(value,"%s",aux1_name); continue;
      }
      if(!strcmp(item,"aux2_name")) {
        sscanf(value,"%s",aux2_name); continue;
      }
      if(!strcmp(item,"aux3_name")) {
        sscanf(value,"%s",aux3_name); continue;
      }
      if(!strcmp(item,"aux4_name")) {
        sscanf(value,"%s",aux4_name); continue;
      }
      if(!strcmp(item,"diag_name")) {
        sscanf(value,"%s",diag_name); continue;
      }
      if(!strcmp(item,"root_name")) {
        sscanf(value,"%s",root_name); continue;
      }
      if(!strcmp(item,"disp_name")) {
        sscanf(value,"%s",disp_name); continue;
      }
      if(!strcmp(item,"MAGNETIC_NORTH")) {
        thePBRec().MAGNETIC_NORTH = atof(value); continue;
      }
      if(!strcmp(item,"ISOLATION_DISTANCE")) {
        thePBRec().ISOLATION_DISTANCE = atof(value); continue;
      }
      if(!strcmp(item,"ISOLATION_DISTANCE2")) {
        thePBRec().ISOLATION_DISTANCE2 = atof(value); continue;
      }
      if(!strcmp(item,"SELECT_TOLRES")) {
        thePBRec().SELECT_TOLRES = atof(value); continue;
      }
      if(!strcmp(item,"SELECT_TOLRESM")) {
        thePBRec().SELECT_TOLRESM = atof(value); continue;
      }
      if(!strcmp(item,"SELECT_CURV0")) {
        thePBRec().SELECT_CURV0 = atof(value); continue;
      }
      if(!strcmp(item,"SELECT_DISTMAX_PROJ_ST")) {
        thePBRec().SELECT_DISTMAX_PROJ_ST = atof(value); continue;
      }
      if(!strcmp(item,"ANGREC_TOLRESC")) {
        thePBRec().ANGREC_TOLRESC = atof(value); continue;
      }
      if(!strcmp(item,"TIME_ERR")) {
        thePBRec().TIME_ERR = atof(value); continue;
      }
      if(!strcmp(item,"TIME_ERR0")) {
        thePBRec().TIME_ERR0 = atof(value); continue;
      }
      if(!strcmp(item,"TIME_ERR_FACTD2")) {
        thePBRec().TIME_ERR_FACTD2 = atof(value); continue;
      }
      if(!strcmp(item,"TIME_ERR_CURV")) {
        thePBRec().TIME_ERR_CURV = atof(value); continue;
      }
      if(!strcmp(item,"TIME_START")) {
        thePBRec().TIME_START = atoi(value); continue;
      }
      if(!strcmp(item,"TIME_START_SELECT")) {
        thePBRec().TIME_START_SELECT = atoi(value); continue;
      }
      if(!strcmp(item,"TIME_START_PLAN")) {
        thePBRec().TIME_START_PLAN = atoi(value); continue;
      }
      if(!strcmp(item,"TIME_START_CURV")) {
        thePBRec().TIME_START_CURV = atoi(value); continue;
      }
      if(!strcmp(item,"TIME_START_GLOB")) {
        thePBRec().TIME_START_GLOB = atoi(value); continue;
      }
      if(!strcmp(item,"LDF_DISTREF")) {
        thePBRec().LDF_DISTREF = atof(value); continue;
      }
      if(!strcmp(item,"LDF_SINTHMAX")) {
        thePBRec().LDF_SINTHMAX = atof(value); continue;
      }
      if(!strcmp(item,"LDF_CHI2MAX")) {
        thePBRec().LDF_CHI2MAX = atof(value); continue;
      }
      if(!strcmp(item,"LDF_DCHI2MAX")) {
        thePBRec().LDF_DCHI2MAX = atof(value); continue;
      }
      if(!strcmp(item,"LDF_DISTMAX_BARY_CORE")) {
        thePBRec().LDF_DISTMAX_BARY_CORE = atof(value); continue;
      }
      if(!strcmp(item,"LDF_DISTMAX_SILENT")) {
        thePBRec().LDF_DISTMAX_SILENT = atof(value); continue;
      }
      if(!strcmp(item,"LDF_SIGTHRESH")) {
        thePBRec().LDF_SIGTHRESH = atof(value); continue;
      }
      if(!strcmp(item,"BARY_POWER")) {
        thePBRec().BARY_POWER = atof(value); continue;
      }
      if(!strcmp(item,"NSTAT_IN_BARY")) {
        thePBRec().NSTAT_IN_BARY = atoi(value); continue;
      }
      if(!strcmp(item,"GLOB_CHI2MAX")) {
        thePBRec().GLOB_CHI2MAX = atof(value); continue;
      }
      if(!strcmp(item,"GLOB_DCHI2MAX")) {
        thePBRec().GLOB_DCHI2MAX = atof(value); continue;
      }
      if(!strcmp(item,"HORIZ_MUON")) {
        thePBRec().HORIZ_MUON = atof(value); continue;
      }
      if(!strcmp(item,"HORIZ_SIGTHRESH")) {
        thePBRec().HORIZ_SIGTHRESH = atof(value); continue;
      }
      if(!strcmp(item,"ANA3_RATMIN")) {
        thePBRec().ANA3_RATMIN = atof(value); continue;
      }
      if(!strcmp(item,"ANA3_AREAMAX")) {
        thePBRec().ANA3_AREAMAX = atof(value); continue;
      }
      if(!strcmp(item,"ANA3_AREAMIN")) {
        thePBRec().ANA3_AREAMIN = atof(value); continue;
      }
      if(!strcmp(item,"ANA3_DISTMAX")) {
        thePBRec().ANA3_DISTMAX = atof(value); continue;
      }
      if(!strcmp(item,"ANA3_CHI2_LDF_MAX")) {
        thePBRec().ANA3_CHI2_LDF_MAX = atof(value); continue;
      }
      if(!strcmp(item,"ANA3_CHI2_LDF_SILENT_MAX")) {
        thePBRec().ANA3_CHI2_LDF_SILENT_MAX = atof(value); continue;
      }
      if(!strcmp(item,"ANA3_DISTMAX_BARY_CORE")) {
        thePBRec().ANA3_DISTMAX_BARY_CORE = atof(value); continue;
      }
      printf("!!! ReadRequest : Keyword  %s  not found \n",item);
    }
  }

  if(thePBRec().Simulation && thePBRec().ReadTruth) {
    //if(!truth_root) truth = fopen(truth_name,"r");
    //else {
    cout << " reading truth : " <<thePBRec().truthroot_name << endl;
    thePBRec().truthroot = new TFile(thePBRec().truthroot_name,"READ");
    //}
  }

  if(thePBRec().Write1_result) thePBRec().res1 = fopen(res1_name,"w");
  if(thePBRec().Write2_result) thePBRec().res2 = fopen(res2_name,"w");
  if(thePBRec().Write3_result) thePBRec().res3 = fopen(res3_name,"w");
  if(thePBRec().Auxil1_output) thePBRec().aux1 = fopen(aux1_name,"w");
  if(thePBRec().Auxil2_output) thePBRec().aux2 = fopen(aux2_name,"w");
  if(thePBRec().Auxil3_output) thePBRec().aux3 = fopen(aux3_name,"w");
  if(thePBRec().Auxil4_output) thePBRec().aux4 = fopen(aux4_name,"w");
  if(thePBRec().Diagno_output) thePBRec().diag = fopen(diag_name,"w");
  if(thePBRec().Display_output) thePBRec().disp = fopen(disp_name,"w");
  if(thePBRec().FitHoriz) thePBRec().ReadHorizTables();
  if(thePBRec().ROOT_output) DefineROOTTrees();

  return 1;
}




int main (int argc, char *argv[]) {
  char output_name[100], root_name[100];

  if (argc==1) {
    cout << "Usage: " << argv[0] << " <files>" << endl;
    cout << "  reconstruct events in <files>" << endl;
    return 1;
  }

  ReadRequest(output_name,root_name);

  thePBRec().PrintLevel = 1;
  thePBRec().Write1_result = 1;
  thePBRec().OpenOutputFiles();

  /*if(thePBRec().Simulation) {
    if(thePBRec().ReadTruth) strcpy(thePBRec().truthroot_name,argv[1]);
    thePBRec().NumEvent = 1000000000;
    }*/
  AugerIoSd input(argc-1, argv+1); //creates the object holding the files
  cout << "Number of events: " << input.NumberOfEvents() << endl;
  IoSd *output = NULL;
  if(thePBRec().Write_sel_evts) output = new IoSd(output_name,"w");

  int nselect = 0;
  int nprocess = 0;
  int nreadlist = 0;

  for (EventPos pos=input.FirstEvent(); pos<input.LastEvent(); pos=input.NextEvent()) {
    TErEvent event(pos);
    cerr<<"event "<<event.AugerId<<endl;
    //creates the event object, with verbose mode choosen;

    // read the "truth" file
    /*if(thePBRec().Simulation && thePBRec().ReadTruth) {
    IoSdSimul* simul=event.simul();
    if(simul==0) {
    if(thePBRec().PrintLevel) printf("!!!! event %d : no simulation block in Simulated data\n",thePBRec().NumEvent); 
    if(thePBRec().Diagno_output) fprintf(thePBRec().diag,"event %d : no simulation block in Simulated data\n",thePBRec().NumEvent); 
    thePBRec().true_ievt=0;
    thePBRec().true_prim=0;
    thePBRec().true_energy=0;
    thePBRec().true_theta=0;
    thePBRec().true_phi=0;
    thePBRec().true_north=0;
    thePBRec().true_east=0;
    thePBRec().true_xmax=0;
    }
    else {
    thePBRec().true_ievt=event.id();
    thePBRec().true_prim=simul->primary();
    thePBRec().true_energy=simul->e();
    thePBRec().true_theta=simul->theta();
    thePBRec().true_phi=simul->phi();
    thePBRec().true_north=simul->corenorthing();
    thePBRec().true_east=simul->coreeasting();
    thePBRec().true_xmax=simul->xmax();
    }
    }*/
    thePBRec().NumEvent = (int)event.AugerId;
    thePBRec().TimeEvent = (int)event.Trigger.Second;
    thePBRec().T4Flag = event.IsT4();

    struct tm *ttt;
    ttt = gmtime(&thePBRec().fErEvent->UTCTime);
    int year = ttt->tm_year+1900;
    int month = ttt->tm_mon+1;
    int day = ttt->tm_mday;
    thePBRec().MonitDay = 10000*(year-2000)+100*month+day;
    thePBRec().TimeInDay = (thePBRec().TimeEvent-13)%86400;

    // select events from a list
    /*if(thePBRec().List_event) {
    int inlist = 0;
    for(int i=0; i<thePBRec().List_event; i++) {
    inlist = ((int)event.Id == thePBRec().list_event[i]);
    if(inlist) break;
    }
    if(!inlist) continue;
    nreadlist++;
    }*/

    // process all events or the events from the list, satisfying the selection at input
    if(!thePBRec().select_input()) {
      if(thePBRec().PrintLevel) printf("--- Event %d rejected at input\n",thePBRec().NumEvent);
      continue;
    }
    if(thePBRec().PrintLevel>1) printf("\n");

    //by default the signals on the good stations are calculated.
    event.Signals();    // calculate the signals and peaks on each pmt.
    thePBRec().nActiveStation = 0;
    /*********************************************/
    nprocess += event.Reconstruct(&thePBRec());
    /*********************************************/

    // writing results of reconstruction on a ROOT tree
    if(thePBRec().ROOT_output) tr_res->Fill();

    // select events to be output
    if(thePBRec().Write_sel_evts) {
      if(select_output()) {
        nselect++;
        output->Write(event);
        cout << event.Id << " written " << event.UTCDate<<endl;
      }
    }
    if(thePBRec().List_event && nreadlist >= thePBRec().List_event) break;
    if(nprocess >= thePBRec().NevMax) break;
  }

  if(thePBRec().Write_sel_evts) output->Close();

  /*if(thePBRec().List_event) printf("---- %d events read from the list\n",nreadlist);
    printf("---- %d events processed --- %d selected for output ---------\n",nprocess,nselect);*/

  if(thePBRec().ROOT_output) {
    TFile *fi_res = new TFile(root_name,"recreate");
    tr_res->Write();
    fi_res->Close();
  }

  return 0;
}
