/** \file 
    Filter for T2 uptime
*/

#include <string>
#include <vector>
#include <fstream>
/** 
    T2 uptime reader

    singleton class
*/
class T2Life
{
 public:

  std::vector<unsigned int>& GetValidStations(unsigned int theGPSSecond);

  /// Get singleton
  static T2Life& GetT2Life();

 private:
  T2Life(const std::string& name);
  ~T2Life();

  static T2Life* gfT2Life;

  unsigned int fCurrentStart;
  unsigned int fCurrentStop;

  std::ifstream fFile;
  std::vector<unsigned int> fValidStations;
};


std::vector<unsigned int>& StationsStatusFromT2Files(unsigned int theGPSSecond);
