/**
   \file
   Implementation of HybridEvent
 
   \author Stefano Argir Antoine Letessier-Selvon
*/

#include <AugerEvent.h>
#include <IoSdData.h>

ClassImp(AugerEvent);

AugerEvent::AugerEvent():
  EventId(0), 
  SEvent(0), 
  Type(eUnknown){};

AugerEvent::~AugerEvent() {
  delete SEvent;
};

AugerEvent::AugerEvent(const AugerEvent & theAugerEvent) {

  SEvent = 0;
  if (theAugerEvent.SEvent)
    SEvent = new IoSdEvent(*theAugerEvent.SEvent);
  Eyes = theAugerEvent.Eyes;
  EventId = theAugerEvent.EventId;

};

AugerEvent & AugerEvent::operator=(const AugerEvent & theAugerEvent) {

  if (this == &theAugerEvent)
    return *this;

  delete SEvent;
  SEvent = 0;
  if (theAugerEvent.SEvent)
    SEvent = new IoSdEvent(*theAugerEvent.SEvent);
  Eyes = theAugerEvent.Eyes;
  EventId = theAugerEvent.EventId;
  return *this;
};


IoSdEvent & AugerEvent::Sd() {
  if (!SEvent)
    cerr << "AugerEvent: SD event not present" << endl;
  return *SEvent;
};

const IoSdEvent& AugerEvent::Sd() const
{
  if (!SEvent) cerr << "AugerEvent: SD event not present" << endl;
  return *SEvent;
}

void AugerEvent::PushEvent(const IoSdEvent & sdevent) {

  if (SEvent)
    delete SEvent;
  SEvent = new IoSdEvent(sdevent);
};

