#include <IoAuger.h>
#include <TFile.h>
#include <TKey.h>

static IoSdEvent *AugerIoSdReader(TFile * f, IoSdKey & key) {
  IoSdEvent *tmp = NULL;
  if (key.ClassName == "AugerEvent") {
    AugerEvent *toto = (AugerEvent *) f->Get(key.Name.c_str());
    if (!toto)
      return NULL;
    toto->EventId = key.EvtId;
    counted_ptr < IoSdEvent > p((IoSdEvent *) toto);
    toto->SEvent->_rawEvent = p;
    tmp = toto->SEvent;
  } else if (key.ClassName == "IoSdEvent") {
    tmp = (IoSdEvent *) f->Get(key.Name.c_str());
    if (!tmp)
      return NULL;
    counted_ptr < IoSdEvent > p(tmp);
    tmp->_rawEvent = p;
  } else {
    cout << "AugerIoSdReader : Unknown Class " << key.
    ClassName << endl;
  }
  return tmp;
};


AugerIoSd::AugerIoSd(const char *name, const char *options):IoSd(name,
    options) {
  theRootInterface()->SetReader(AugerIoSdReader);
};

AugerIoSd::AugerIoSd(int nfiles, char *names[],
                     const char *options):IoSd(nfiles, names, options) {
  theRootInterface()->SetReader(AugerIoSdReader);
};

AugerIoSd::AugerIoSd(std::vector < std::string > files):IoSd(files) {
  theRootInterface()->SetReader(AugerIoSdReader);
};
