
//
// File   : EyeT3Data.cc
//
// Purpose: Implementation of the class TEyeT3Data
//
// $Id: EyeT3Data.cc 8757 2010-09-27 12:16:09Z mathes $
//


#include <iostream>


/** @file EyeT3Data.cc
  * Implementation of the class TEyeT3Data.
  * @author H.-J. Mathes, FzK
  */


#include "CheckVersion.hh"

#include "EyeT3Data.hh"

using namespace std;

// -------------------------------------------------------------------------
// -------------------------------------------------------------------------
// 
// class TEyeT3Data - implementation
// 

ClassImp(TEyeT3Data)

const float TEyeT3Data::kInvalidValue = 9999.0;

TEyeT3Data::TEyeT3Data()
 {
  Reset();
}
 
// -------------------------------------------------------------------------

void TEyeT3Data::Reset()
 {
  fNPixels         = 0;
  fSDPTheta        = kInvalidValue;
  fSDPPhi          = kInvalidValue;
  fAzimuthAtGround = kInvalidValue;
  fTimeAtGround    = UInt_t(kInvalidValue);
}

// -------------------------------------------------------------------------

void TEyeT3Data::Show(std::ostream& ostr)
 {
  ostr << "--- TEyeT3Data ---" << endl;
  
  ostr << " NPixels=        " << fNPixels << endl;
  ostr << " SDP-Theta=      " << fSDPTheta << " [rad]" << endl;
  ostr << " SDP-PHI=        " << fSDPPhi << " [rad]" << endl;
  ostr << " AZ-at-Ground=   " << fAzimuthAtGround << " [rad]" << endl;
  ostr << " Time-at-Ground= " << fTimeAtGround << " [nsec]" << endl;
  
  ostr << "------------------" << endl;
}

// -------------------------------------------------------------------------
// -------------------------------------------------------------------------
