
//
// File   : CheckVersion.hh
//
// Purpose: File to be included by all *.cc files to check the software versions
//
// $Id: CheckVersion.hh 8759 2010-09-27 12:16:36Z mathes $
//


/** @file CheckVersion.hh
  * Macro file for software version checking.
  * @author H.-J. Mathes, FzK
  */

#ifndef _CheckVersion_hh_
#define _CheckVersion_hh_

#ifndef __CINT__

#ifndef NO_VERSION

/* --- Check against version of package FdUtil ... --- */

# include <FdUtilVersion.hh>
# if (FDUTIL_VERSION_CODE < ModuleVersionCode(4,0,0) \
      || FDUTIL_VERSION_CODE > ModuleVersionCode(4,1,255))
#  error "Version of module FdUtil does not match !"
#  error "Required version: 4.0.0 ... 4.1.x"
# endif // FDUTIL_VERSION_CODE

/* --- Check against version of package Shm ... --- */

# ifndef DPA
#  include <ShmVersion.h>
#  if (SHM_VERSION_CODE < ModuleVersionCode(1,3,1) \
       || SHM_VERSION_CODE > ModuleVersionCode(1,3,255))
#   error "Version of module Shm does not match !"
#   error "Required version: 1.3.1 ... 1.3.x"
#  endif // SHM_VERSION_CODE
# endif // DPA

#endif // NO_VERSION

#endif // __CINT__

#endif // _CheckVersion_hh_
