
//
// File   : MiEventTypes.hh
//
// Purpose: Some general types used MiEvent* header files.
//
// $Id: MiEventTypes.hh 8759 2010-09-27 12:16:36Z mathes $
//

/** @file MiEventTypes.hh
  * @brief Some general types used MiEvent* header files.
  */

#ifndef _MiEvent_MiEventTypes_hh_
#define _MiEvent_MiEventTypes_hh_

namespace MiEvent {

/** A special tag which is used to signal the destructors how the
  * objects have been created.
  */
typedef enum {
      
  /** Was created on the heap. */
  kCREATE, 
  /** Was created from SHM data structures (for TMirrorEvent). */
  kSHMEVENT, 
      
  /** Was created from C-struct MiEventHeaderRec. */
  kMIEVENTHEADER, 
  /** Was created from C-struct MiFADCDataRec. */
  kMIFADCDATA, 
  /** Was created from C-struct MiPixelDataRec. */
  kMIPIXELDATA, 
  /** Was created from C-struct MiPixelListRec. */
  kMIPIXELLIST,
  /** Was created from C-struct MiTriggerDataRec. */
  kMITRIGGERDATA
      
} EConstructorType;


typedef EConstructorType Constructor_t;

} // namespace MiEvent

#endif // _MiEvent_MiEventTypes_hh_
