
//
// File   : MiEventVersionDefines.hh
//
// Purpose: Definition of version number macros.
//
// $Id: MiEventVersionDefines.hh 8759 2010-09-27 12:16:36Z mathes $
//

/** @file MiEventVersionDefines.hh
  * @brief Definition of version number macros.
  */

#ifndef _MiEventVersionDefines_hh_
#define _MiEventVersionDefines_hh_

/* --- the very important versioning information !!! --- */

/** Data structure version number for the new format (v4r1). */
#define MiEVENTVERSIONv8     8

/** Data structure version number for the new format (v4r0). */
#define MiEVENTVERSIONv7     7

/** Data structure version number for the new format (v2r4, v3r0, v3r1). */
#define MiEVENTVERSIONv6     6

/** Data structure version number for the new format (v2r1, v2r2, v2r3). */
#define MiEVENTVERSIONv5     5

/** Data structure version number for the new format (v1r4, v1r5 & v2r0). */
#define MiEVENTVERSIONv4     4

/** Data structure version number for the new format (v1r3). */
#define MiEVENTVERSIONv3     3

/** Data structure version number for the new format (v1r2). */
#define MiEVENTVERSIONv2     2

/** Data structure version number for the actual file. */
#define MiEVENTVERSIONv1     1

/** Current data structure version. */
#define MiEVENTVERSION       MiEVENTVERSIONv1

#endif // _MiEventVersionDefines_hh_
 
