
//
// File   : CameraGeometry.hh
//
// Purpose: Definition of constants of a single camera (pixel pointings)
//
// $Id: CameraGeometry.hh 9725 2010-09-28 07:31:17Z mathes $
//


#ifndef _CameraGeometry_hh_
#define _CameraGeometry_hh_


/** @file CameraGeometry.hh
  * Definition of pixel pointings constants of a single camera.
  * @author P. Privitera & P. Facal
  */
  
#include <Rtypes.h>

/** Table of 440 pixel azimuths. */
extern Float_t gPixelAzimuth[];

/** Table of 440 pixel elevation angles. */
extern Float_t gPixelElev[];

#endif // _CameraGeometry_hh_
