
//
// File   : FEMiEvent.cc
//
// Purpose: Implementation of the class FEMirrorEvent
//
// $Id: FEMiEvent.cc 9725 2010-09-28 07:31:17Z mathes $
//


/** @file FEMiEvent.cc
  * Implementation of the class FEMirrorEvent
  * @author R. Ulrich, FzK
  */

#include <FdNumbering.hh>

#include <MiEvent.hh>

#include "VirtualReadout.hh"
#include "FEPageDesc.hh"

#include "FEMiEvent.hh"

// -------------------------------------------------------------------------
// -------------------------------------------------------------------------
//
// class FEMirrorEvent - implementation
//

FEMirrorEvent::FEMirrorEvent(VirtualReadout* r, FEPageDesc* p)
 : fReadout (r), fPage (p) { }

// -------------------------------------------------------------------------

TMirrorEventHeader* FEMirrorEvent::GetEventHeader() {    
  return fReadout->GetEventHeader( fPage );
}

// -------------------------------------------------------------------------

TMirrorPixelData* FEMirrorEvent::GetPixelData() {
  return fReadout->GetPixelData( fPage );
}

// -------------------------------------------------------------------------

TFADCData* FEMirrorEvent::GetFADCData( FdUtil::Fd::PixelNumber pixel ) {
  return fReadout->GetFADCData( fPage, pixel );
}

// -------------------------------------------------------------------------

TFADCData* FEMirrorEvent::GetFADCData(FdUtil::Fd::PixelNumber pixel,
				      TFADCData::FADCTraceInfo info) {
  return fReadout->GetFADCData( fPage, pixel, info );
}

// -------------------------------------------------------------------------

TFADCData::PixelMonitorData 
FEMirrorEvent::GetMonitorData( FdUtil::Fd::PixelNumber pixel) {
  return fReadout->GetMonitorData( fPage, pixel );
}

// -------------------------------------------------------------------------

#if (MIEVENT_VERSION_CODE >= ModuleVersionCode(4,0,0))
TMirrorEventHeader::EMiTriggerSource FEMirrorEvent::GetTriggerSource() {
  return fPage->GetTriggerSource();
#else
int FEMirrorEvent::GetTriggerSource() {
  return (TMirrorEventHeader::EMiTriggerSource)fPage->GetTriggerSource();
#endif // MIEVENT_VERSION_CODE
}

// -------------------------------------------------------------------------
// -------------------------------------------------------------------------
