
//
// File   : MiReadout.hh
//
// Purpose: New command tag definition file for the readout process
//
// $Id: MiReadout.hh 9725 2010-09-28 07:31:17Z mathes $
//


/** @file MiReadout.hh
  * Declaration of commands and messages to/from the readout process.
  * @author H.-J. Mathes, FzK
  */
  
#ifndef _MiReadout_hh_
#define _MiReadout_hh_

#include <ReadoutCmd.hh>
#include <ReadoutConfig.hh>

#ifndef NO_VERSION
# include <MiReadoutVersion.hh>
#endif // NO_VERSION

// former content of Readout.hh:

/** Adress family of the socket to the readout process.
  */
#define READOUT_ADDRESS_FAMILY  AF_INET

#if defined READOUT_ADDRESS_FAMILY && (READOUT_ADDRESS_FAMILY == AF_UNIX)
        /** Name of the unix domain socket to the readout process. */
# define READOUT_SERVICE_NAME	"/tmp/readout"
        /** Port number of the service offered by the readout process.
	  * Meaningless in the case of an unix domain socket.
	  */
# define READOUT_SERVICE_PORT	0
#else
        /** Name of the inet domain socket to the readout process. */
        /** Port number of the service offered by the readout process. */
# define READOUT_SERVICE_NAME	"readout"
# define READOUT_SERVICE_PORT	10000
#endif
        /** Number of clients to be accepted by the 
	  * readout process' socket server.
	  */
#define READOUT_MAX_CLIENTS     1

#endif  // _MiReadout_hh_
