
//
// File   : SltPattern.cc
//
// Purpose: Implementation file for class SltPattern
//
// $Id: SltPattern.cc 9725 2010-09-28 07:31:17Z mathes $
//


#include <iostream>
#include <cmath>

/** @file SltPattern.cc
  * Implementation of the class SltPattern.
  * @author H.-J. Mathes, FzK
  */

#include "CheckVersion.hh"
#include "SltPattern.hh"

using namespace std;

// -------------------------------------------------------------------------
// -------------------------------------------------------------------------
//
// class SltPattern - implementation
//

// class SltPattern - static data area

#include "SltPatternData.hh"

//
// This is the meaning of the data:
//
// Starting from a given pixel there are kNDirection different pixels 
// which could be next on a valid track. 
// Traversing in any of these 'directions' means, that
//  - fgRow[] the row number is changing
//  - fgColOdd[], fgColEven[] the column number is changing
//    this depends on whether the starting pixel was in an even or odd column
// The fgPattern[][3] shows for a given pattern which are the next pixels
// belonging to the actual pattern expressed in 'direction' units.
// Near the borders of the camera (pixel matrix) some pattern could not start
// above/below a given row (fgMinRow[],fgMaxRow[]).
// Expressed in terms of the pixel numbers (1...440) fgDiffOdd[][3] and
// fgDiffEven[][3] show the pixel number differences to the next pixel of
// the actual pattern.
//

// -------------------------------------------------------------------------
// -------------------------------------------------------------------------
