
//
// File   : SltPattern.hh
//
// Purpose: Header file for class SltPattern
//
// $Id: SltPattern.hh 9725 2010-09-28 07:31:17Z mathes $
//


/** @file SltPattern.hh
  * Declaration of the class SltPattern.
  * @author H.-J. Mathes, FzK
  */

#ifndef _SltPattern_hh_
#define _SltPattern_hh_

#include <iostream>

/** Data class to describe the valid pattern in the SLT data. 
  */
class SltPattern {

public:
    /** Number of possible directions from a pixel, 1 .. 6 are the direct
      * neighbors, starting from top left pixel, counter clockwise.
      */
    static const int kNDirection = 18;

    /** Number of possible patterns in the SLT firmware. */
    static const int kNPattern = 108;

    /** Max. number of pixels in a pattern.  */
    static const unsigned int kNPixel = 4;
    
    /** This pattern is the 'invalid pattern'. */
    enum { kNoPattern = 127 };

public:
    static short fgRow[kNDirection];
    static short fgColOdd[kNDirection];
    static short fgColEven[kNDirection];
    static short fgPattern[kNPattern][3];
    static short fgDiffOdd[kNPattern][3];
    static short fgDiffEven[kNPattern][3];
    static short fgMinRow[kNPattern];
    static short fgMaxRow[kNPattern];
};

#endif  // _SltPattern_hh_
