
//
// File   : VTltProcessor.cc
//
// Purpose: Implementation of the class VTltProcessor
//
// $Id: VTltProcessor.cc 9725 2010-09-28 07:31:17Z mathes $
//


#include <iostream>
#include <cstdio>


/** @file VTltProcessor.cc
  * Implementation of the class VTltProcessor.
  * @author H.-J. Mathes, FzK
  */

#include <ErrorLogging.hh>

#include <MiReadout.hh>

#include "CheckVersion.hh"

#include "VTltProcessor.hh"

using namespace std;
using namespace MiReadout;

// -------------------------------------------------------------------------
// -------------------------------------------------------------------------
// 
// class VTltProcessorBase - implementation
// 

static FILE * gDefaultTltLogfile = fopen("/dev/null", "w");

int VTltProcessor::fgPrintLevel = 0;

VTltProcessor::VTltProcessor(const char *name)
 : fTltLogfile(gDefaultTltLogfile),
   fEventAccepted(false), fEventLabel(TMirrorEventHeader::kUnlabelled),
   fTltType(kUnknown)
 {
  if ( name == NULL || *name == 0 ) {
    FD_CWARN << "VTltProcessor::VTltProcessor() - no name provided !" << endl;
    fName = "NoName";
  }
  else
    fName = name;
}

// -------------------------------------------------------------------------

string VTltProcessor::GetVerboseTltType(ETltType tlt_type)
 {
  switch ( tlt_type ) {
    case kUnknown:
         return "unknown";
    case kPrototype:
         return "prototype";
    case kMultiplicity:
         return "multiplicity";
    case kMStc:
         return "mstc";
    default:
         return "unknown";
  }
}

// -------------------------------------------------------------------------
// -------------------------------------------------------------------------
