
//
// File   : CheckVersion.hh
//
// Purpose: File to be included by all *.cc files to check the software versions
//
// $Id: CheckVersion.hh 8758 2010-09-27 12:16:24Z mathes $
//


/** @file CheckVersion.hh
  * Macro file for software version checking.
  * @author H.-J. Mathes, FzK
  */

#ifndef _CheckVersion_hh_
#define _CheckVersion_hh_

#ifndef __CINT__

#ifndef NO_VERSION

/* --- Check against version of external package ROOT ... --- */

# include <RVersion.h>
# if (ROOT_VERSION_CODE < ROOT_VERSION(3,5,7) \
      || ROOT_VERSION_CODE > ROOT_VERSION(5,24,0))
#  warning "Version of ROOT package does not match tested versions !"
#  warning "Required version: 3.05/07 .. 5.24/00"
# endif

#endif // NO_VERSION

#endif // __CINT__

#endif // _CheckVersion_hh_
