#!/bin/sh

# builds the FDEventLib under CMT for Mac (minor change needed for Linux)
# BEWARE : file Util/src/Inifile.hh on macs may be overwritten by inifile.hh. Only Inifile.hh is usefull.
# Need to remove call to cuserid in Util/FdNaming.cc 
# remove check of SHM_VERSION in MiEvent/Check$Version.hh


FD=/home/antoine/FDEventLib-devel-28072004
#FD=/Raid/opt/CDAS/FDEventLib/v2r4
IoFd=/Raid/tmp/Merger2/IoFd
IoFdVersion=v2r5
# Subpackages (EyeEvent,MiEvent,Util) version is useless (all is driven by IoFdVersion) but it must be present
Version=v99

currentDir=`pwd`
installDir=$IoFd/InstallArea/`uname`/lib

echo "*****************************************************************************************"
echo "1] original FDEventLibTaken from $FD"
echo "2] cmt version placed in $IoFd/$IoFdVersion with subpackages version $Version"
echo "3] install area for dylib will be $installDir"
echo "*****************************************************************************************"
echo "xmkmf -a must have been run on the original FDEventLibrary before running this script !!!"
echo "*****************************************************************************************"
echo "OK to continue ?? (crtl-C to abort)"
read toto

################### prepare directories ################################
mkdir -p $installDir
mkdir -p $IoFd
cd $IoFd/..
cmt create IoFd $IoFdVersion

################################### UTIL ###############################
cd $IoFd/$IoFdVersion/


#util/src
cmt create Util $Version
cp $FD/util/src/*.cc Util/$Version/src/
cp $FD/util/src/*.hh Util/$Version/src/
cp $FD/util/src/UtilLinkDef.h Util/$Version/src/UtilLinkDef.hh

#util/root
cp $FD/util/root/*.cc Util/$Version/src/
cp $FD/util/root/*.hh Util/$Version/src/
cp $FD/util/root/UtilLinkDef.h Util/$Version/src/RootUtilLinkDef.hh

#util/src/Inifile.hh ...
cp $FD/util/src/Inifile.hh Util/$Version/src/


#now the requirement file 
cat > Util/$Version/cmt/requirements << 'END'
package Util

macro cppflags "" \
	Linux " " \
	Darwin " -D__DARWIN__"

use RootW v2r6

macro CINT_use_includes " -I/Raid/opt/root/include"

make_fragment rootdict_header
make_fragment hhrootdict -suffix=hh -header=rootdict_header


document hhrootdict UtilDict FdNumbering.hh FdConfig.hh TimeConvert.hh Configuration.hh FdNaming.hh UtilLinkDef.hh

library Util Inifile.cc FdConfig.cc TimeConvert.cc FdNumbering.cc Configuration.cc FdNaming.cc UtilDict.cc

document hhrootdict RootUtilDict  TIniFile.hh TNanoDatime.hh TTimeStamp.hh RootUtilLinkDef.hh

library RootUtil TIniFile.cc TRawSocketAcceptor.cc  TSocketAcceptor.cc  TTimeStamp.cc  TNanoDatime.cc  RootUtilDict.cc


macro_append Util_linkopts " -L$(UTILROOT)/$(Util_tag)"
macro_append Util_linkopts "" \
        Linux " -Wl,-rpath $(UTILROOT)/$(Util_tag) -lUtil -lRootUtil" \
        Darwin " -lUtil  -lRootUtil"

END
#now the fragments to build the root dictionnary from the .hh files
mkdir -p Util/$Version/cmt/fragments
touch Util/$Version/cmt/fragments/hhrootdict
cat > Util/$Version/cmt/fragments/rootdict_header << 'END'
#-------------------------------------------

src     = ../src/

${CONSTITUENT}_output = $(src)
  
${CONSTITUENT} :: $(src)/${CONSTITUENT}

$(src)/${CONSTITUENT} :: ${OBJS}
	cd $(src); ${ROOTBIN}/rootcint -f ${CONSTITUENT}.cc -c ${CINTOPT} ${CINT_use_includes} ${OBJS}; touch ${CONSTITUENT}
	@/bin/echo "---> ${CONSTITUENT} ok"
                 
${CONSTITUENT}clean ::
	/bin/rm -f .rootsys
	cd $(src); /bin/rm -f ${CONSTITUENT} ${CONSTITUENT}.h; echo >${CONSTITUENT}.cc
 
#-------------------------------------------                                    
END
################### END OF UTIL ##########################################

################### MIEVENT #############################################
cd $IoFd/$IoFdVersion
cmt create MiEvent $Version

cp $FD/MiEvent++/*.cc MiEvent/$Version/src
cp $FD/MiEvent++/*.hh MiEvent/$Version/src
cp $FD/MiEvent++/*.h MiEvent/$Version/src

mv MiEvent/$Version/src/MiEventLinkDef.h MiEvent/$Version/src/MiEventLinkDef.hh
mv MiEvent/$Version/src/MiIdLinkDef.h MiEvent/$Version/src/MiIdLinkDef.hh
mv MiEvent/$Version/src/MiRunLinkDef.h MiEvent/$Version/src/MiRunLinkDef.hh

#Shm stuff is useless off-line
rm MiEvent/$Version/src/*Shm*.*

# a dummy checkversion file to overide the use of Shm
cat > MiEvent/$Version/src/CheckVersion.hh<<'END'
#ifndef _CheckVersion_hh_
#define _CheckVersion_hh_
#endif // _CheckVersion_hh_
END

#now the requirement file
cat > MiEvent/$Version/cmt/requirements << END
package MiEvent
use Util v* IoFd/$IoFdVersion
END
cat >> MiEvent/$Version/cmt/requirements << 'END'

macro CINT_use_includes " -I/Raid/opt/root/include -I${UTILROOT}/src"

document hhrootdict MiEventDict  MiEvent.hh MiEventHeader.hh MiPixelData.hh MiPixelList.hh MiFadcData.hh FadcData.hh MiEventFile.hh MiBitArray.hh MiTriggerData.hh MiEventLinkDef.hh

document hhrootdict MiIdDict MiId.hh MiIdLinkDef.hh
document hhrootdict MiRunDict MiRunHeader.hh MiRunTrailer.hh MiRunLinkDef.hh

library MiEvent MiEvent.cc MiEventHeader.cc MiPixelData.cc MiPixelList.cc MiFadcData.cc FadcData.cc MiTriggerData.cc MiEventDict.cc MiId.cc MiIdDict.cc MiRunHeader.cc MiRunTrailer.cc MiRunDict.cc MiEventFile.cc MiBitArray.cc

macro_append MiEvent_linkopts " -L$(MIEVENTROOT)/$(MiEvent_tag)"
macro_append MiEvent_linkopts "" \
        Linux " -Wl,-rpath $(MIEVENTROOT)/$(MiEvent_tag) -lMiEvent" \
        Darwin " -lMiEvent "

END
################### END OF MIEVENT ##########################################

################### EYEEVENT ##########################################

cd $IoFd/$IoFdVersion/
cmt create EyeEvent $Version

cp $FD/EyeEvent/src/*.cc EyeEvent/$Version/src/
cp $FD/EyeEvent/src/*.hh EyeEvent/$Version/src/
cp $FD/EyeEvent/src/*.h EyeEvent/$Version/src/

mv EyeEvent/$Version/src/EyeEventLinkDef.h EyeEvent/$Version/src/EyeEventLinkDef.hh

#now the requirement file
cat > EyeEvent/$Version/cmt/requirements << END
package EyeEvent
use MiEvent v* IoFd/$IoFdVersion
END

cat >> EyeEvent/$Version/cmt/requirements << 'END'

macro CINT_use_includes " -I/Raid/opt/root/include -I${UTILROOT}/src -I${MIEVENTROOT}/src"

document hhrootdict EyeEventDict  EyeEvent.hh EyeEventHeader.hh EyeFadcData.hh EyePixelData.hh EyePixelList.hh EyeRunHeader.hh  EyeRunTrailer.hh EyeEventFile.hh EyeWeatherData.hh EyeTriggerData.hh EyeT3Data.hh EyeEventLinkDef.hh 

library EyeEvent EyeEvent.cc EyeEventHeader.cc EyeFadcData.cc EyePixelList.cc EyePixelData.cc EyeRunHeader.cc EyeRunTrailer.cc EyeEventDict.cc EyeEventFile.cc EyeWeatherData.cc EyeTriggerData.cc EyeT3Data.cc

macro_append EyeEvent_linkopts " -L$(EYEEVENTROOT)/$(EyeEvent_tag)"
macro_append EyeEvent_linkopts "" \
        Linux " -Wl,-rpath $(EYEEVENTROOT)/$(EyeEvent_tag) -lEyeEvent" \
        Darwin " -lEyeEvent"
END
################### END OF EYEEVENT ##########################################

######################## IoFd #################################################

cd $IoFd/$IoFdVersion/cmt
cat > requirements <<END
package IoFd

use EyeEvent v* IoFd/$IoFdVersion
END

echo "Now you need to build the packages i.e. in $IoFd/$IoFdVersion/cmt:"
echo "$ cmt broadcast -depth=2 cmt config"
echo "$ cmt broadcast -depth=2 make "

echo "Then on MAC put the link to the dylibs in the install area (for Mac only)"
echo "$ ln -fs $IoFd/$IoFdVersion/EyeEvent/$Version/`uname`/libEyeEvent.dylib $installDir "
echo "$ ln -fs $IoFd/$IoFdVersion/MiEvent/$Version/`uname`/libMiEvent.dylib $installDir "
echo "$ ln -fs $IoFd/$IoFdVersion/Util/$Version/`uname`/libUtil.dylib $installDir "
echo "$ ln -fs $IoFd/$IoFdVersion/Util/$Version/`uname`/libRootUtil.dylib $installDir "
#
cd $currentDir
