#!/bin/bash

# Usage:
# shell> . io_md_compiler.sh 
# 
# The script will ask you to enter the complete PATH were you installed the CDAS 
# If the CMT is installed within your CDAS, then you only need to have defined the
# ROOTSYS variable
# 
#
#
#
#
#
#
#
#
#
#

remove_dicts()
{
   find $IOMDDIR -name *Dict* | xargs -I{} rm {}
}

error() {
  echo
  echo $*
  echo "PATH was $PATH"
  return
}

io_md_compiler()
{
  cd $IOMDDIR/cmt
  cmt config
  make || error "Cannot compile IoMd"
}

echo "Enter the PATH where you intalled the current CDAS"
read DIR
IOMDDIR=$DIR/IoMd/v1r2
echo "cheking sources of IoMd library..."
! test -d $IOMDDIR && echo "sources not found in: $IOMDDIR... exiting" && echo "" && return
echo "ok..."

CMTROOT=$DIR/CMT/$(ls $DIR/CMT)

[ "X$CMTROOT" = "X" ] && echo "CMTROOT not defined. CMT is not installed on this machine or not well configured" && return
[ -f "$CMTROOT/mgr/setup.sh" ] && . $CMTROOT/mgr/setup.sh
export CMTPATH=$DIR
remove_dicts
io_md_compiler
cd $DIR

