#ifndef _MD_SCINTI_H
#define _MD_SCINTI_H

#include "TObject.h"
#include "MdSignal.h"

namespace md {

class Channel : public TObject {

public:

   Channel(); ///< Default constructor
   Channel( const Channel & ); ///< Copy constructor
   Channel( ID ); ///< Id constructor
   virtual ~Channel(); ///< Default destructor

   //void AddData( Data mdSig ){ fData = mdSig;}///< Associate a signal to scintillator

   void SetId( ID id ){ fId = id;}///< Set scintillator id (1-64)
   ID  GetId( ) { return fId;} ///< Get scintillator id (1-64)

   Signal & GetSignal(){ return fSignal;}///< Get reference to data class
   bool HasSignal(){ return fSignal.IsEmpty(); }///<

private:

   Signal fSignal;///< Channel associated data
   ID     fId;///< Channel Id (1-64)

   ClassDef(Channel,1)  //Channel structure
};

}//end namespace
#endif
