#include "MdCounter.h"
#include <iostream>
using std::cout;
using std::endl;

namespace md {
////////////// Ctrs and Dtrs /////////////////////
Counter::Counter() : fId(-1) , fT3Delay( -1)
{
};

Counter::Counter( const Counter & mdCtr) : TObject()
{
   *this = mdCtr;
};

Counter & Counter::operator=( const Counter & mdCtr)
{
 fId       = mdCtr.fId;
 fT3Delay  = mdCtr.fT3Delay;
 ClearModules();
 for(ConstIterator i = mdCtr.ModulesBegin(), e = mdCtr.ModulesEnd() ; i != e; ++i ){
    fModList.push_back(new Module(**i));
  }
  return *this;
};

Counter::Counter( ID id ): fId( id ) , fT3Delay( -1)
{
};

Counter::~Counter()
{
   this->ClearModules();
};
//////////////////////////////////////////////////
void Counter::ClearModules(){
   DeleteModules();
   fModList.clear();
};

void Counter::DeleteModules(){
   for(Iterator i = ModulesBegin(), e = ModulesEnd() ; i != e; ++i )
       delete *i;
};

void Counter::EraseModule( Iterator sPos )
{
  delete *sPos;
  fModList.erase( sPos );
}

void Counter::EraseModules( Iterator sStart, Iterator sEnd ){
   for(Iterator i = sStart, e = sEnd ; i != e; ++i )
       delete *i;
   fModList.erase( sStart, sEnd );
};

void Counter::AddModule ( const Module & m){
  Module * mdMod = new Module( m );
  fModList.push_back( mdMod );
//  fModList.push_back( counted_ptr<Module>(mdMod) );
};

Module * Counter::MakeModule( ID id )
{
  Module * mdMod = new Module( id );
  mdMod->SetId( id );
  //fModList.push_back( counted_ptr<Module>(mdMod) );
  mdMod -> SetId(id);
  fModList.push_back( mdMod );
  return mdMod;
};

Module * Counter::GetModule( ID id )
{
  for(Iterator i = ModulesBegin(), e = ModulesEnd() ; i != e; ++i )
    if( (*i)->GetId() == id )
    {
      //return (*i).get();
      return (*i);
      break;
    }

    //ID not found
    return 0;
};

Module * Counter::HasModule( ID id )
{
   return GetModule( id );
};
}//end namespace
