#include "MdKey.h"
#include <sstream>

namespace md {

const std::string Key::fStringTypes[fTrgTypes] = 
{ 
    "Occupancy",
    "T3",
    "None"
};

Key::Key(): fEventId(0), fNumberOfCounters(0), fTriggerAlgo(""), fType(eNone) {};

Key::~Key(){};

Key::Key( Event & event) 
{
  fEventId = event.GetId();
  fNumberOfCounters = event.HasCounters();
  std::ostringstream talgo;

  if( event.GetTrigger().Type() == Trigger::eOccupancy )
      talgo << "#OCC" << event.GetTrigger().OccupancyLevel();
  else if( event.GetTrigger().Type() == Trigger::eT3 )
      talgo << "#T3";
  else
      talgo << "#";

  talgo << "#Id:" << fEventId << "#Counters:" << fNumberOfCounters << "#";
  fTriggerAlgo = talgo.str(); 
};

}//end namespace
