#ifndef _MdKey_h_
#define _MdKey_h_

#include <string>

#include "MdEvent.h"

namespace md {

class Key  {

public:

  typedef unsigned int EventId;

  enum EventType { eOccupancy,
                   eT3, 
                   eNone
                 };

  Key();
  Key( Event & event);
  virtual ~Key();

  EventId fEventId;
  unsigned int fNumberOfCounters;

  ///Trigger Algo string
  std::string fTriggerAlgo;

  EventType fType;

private:

  static const unsigned int fTrgTypes = eNone + 1;
  static const std::string fStringTypes[fTrgTypes];
};                            

}//end namespace
#endif                         
