#include "MdSignal.h"
#include <iostream>
using std::cout;
using std::endl;

namespace md {

Signal::Signal() : fGPSTime( -1 ) , fEChannel( -1 ) 
{};

Signal::Signal( const Signal & mdSig) : TObject()
{
   *this = mdSig;
};

Signal & Signal::operator=( const Signal & mdSig)
{
 fGPSTime  = mdSig.fGPSTime;
 fEChannel = mdSig.fEChannel;
 ClearSignal();
 for(ConstIterator i = mdSig.Begin(), e = mdSig.End() ; i != e; ++i ){
    fSigSamples.push_back(new RawSample(**i));
  }
  return *this;
};

Signal::Signal( GPSTime gps = -1, eChannel ch = -1 ) 
{
 fGPSTime  = gps;
 fEChannel = ch;
};

Signal::~Signal()
{
   this->ClearSignal();
};
//////////////////////////////////////////////////
void Signal::ClearSignal(){
   DeleteSignal();
   fSigSamples.clear();
};

void Signal::DeleteSignal(){
   for(Iterator i = Begin(), e = End() ; i != e; ++i )
       delete *i;
};

void Signal::EraseSignal( Iterator rPos )
{
  delete *rPos;
  fSigSamples.erase( rPos );
}
 
void Signal::EraseSignals( Iterator rStart, Iterator rEnd ){
   for(Iterator i = rStart, e = rEnd ; i != e; ++i )
       delete *i;
   fSigSamples.erase( rStart, rEnd );
};

void Signal::AddSample( unsigned int tbin, Long64_t sample )
{
 RawSample * mdraw = new RawSample( tbin, sample ); 
 fSigSamples.push_back( mdraw );
}

}//end of namespace
