#ifndef _MD_RAWSAMPLE_H
#define _MD_RAWSAMPLE_H

#include "TObject.h"
#include <vector>

namespace md {

class RawSample : public TObject {
  public:
    RawSample(); ///< Default constructor
    RawSample( const RawSample & ); ///< Copy constructor
    RawSample & operator=( const RawSample & ); ///< 
    RawSample(unsigned int, Long64_t ); ///< constructor
    virtual ~RawSample(); ///< Default destructor

    Long64_t GetSample(){ return fSample;}
    unsigned int GetTimeBin(){ return fTimeBin;}

    void SetSample(Long64_t s ){ fSample = s;}
    void SetTimeBin( unsigned int t ){ fTimeBin = t; }

  private:
    Long64_t fSample;
    unsigned int fTimeBin;
    ClassDef(RawSample,1)  //Raw sample structure
};

}//end namespace
#endif
