#include "IoSdFile.h"

IoSdKey::IoSdKey(TKey * k, int filenumber) {
  const char *name = k->GetName();
  Name = name;
  ClassName = k->GetClassName();
  FileNumber = filenumber;

  if ((ClassName == "AugerEvent") && !strstr(name, "#Fd-only")) {
    EventId id;
    unsigned int sdmul, fdmul, npix, fdpatt;
    char algo[30];
    sscanf(name, "%llu#%u#%u#%u#%u#%s", &id, &sdmul, &fdmul, &npix,
           &fdpatt, algo);
    EvtId = id;
    Multiplicity = sdmul;
    T3Algo = strchr(algo, '#') + 1;
    //      cout << EvtId << " " << Multiplicity << " " << T3Algo << endl;
    return;
  }

  if ((ClassName == "IoSdEvent") && strchr(name, '#')) {
    EventId id;
    unsigned int mul;
    char algo[20];
    sscanf(name, "%llu#%u#%s", &id, &mul, algo);
    EvtId = id;
    Multiplicity = mul;
    T3Algo = algo;
    return;
  }
};




// ---------------------------------------------------------
IoSdFile::IoSdFile(const char *name) {
  Nentries = 0;
  FileName = name;
  if (!(File = new TFile(FileName.c_str(), "READ")) || File->IsZombie()) {
    cerr << "Impossible to open file " << FileName << endl;
    return;
  }
  Nentries = File->GetNkeys();
};

// ---------------------------------------------------------
IoSdFile::~IoSdFile() {
  if (File) {
    File->Delete("*;*");
    File->Close();
    delete File;
  }
};

// ---------------------------------------------------------
IoSdFile::IoSdFile(const IoSdFile & f) {
  File = NULL;
  FileName = f.FileName;
  Nentries = f.Nentries;
};
