#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <fstream>

//----------------------------------------------------------------------------------------------
//   3 types of atmospheric effects at the same (r,DX) :
//          Type I --> Showers with the same (theta,psi) but different rho_ground
//          Type II--> Showers with the same (psi,rho_ground)  show theta depedences. 
//          Type III--> Showers with the same (theta,rho_ground) show psi depedences due to the different atmospheric profiles 
//----------------------------------------------------------------------------------------------

// Remarks :
//    -A wrong attenuation parameter can also induce azimuthal asymmetries that can be confused with atmospheric effects

// Corrections calculated using pQGSJetII 


namespace AtmCorrNS {

  class AtmCorr {

  private:
    int fDetectorType;
  public:
    AtmCorr(int DetectorType);    
    ~AtmCorr(){};

    //Type I atmospheric effect
    double GetAlphaRho(double r,int icomp);
    double GetCorrTypeI( double r, int icomp, double rhoGround, double hGround); 

    //Type II atmospheric effects
    double GetCorrTypeII( double r, double theta, int icomp, double hground);

    //Type III atmospheric effect
    double GetParCorrTypeIII( double r,  int icomp, int ipar );
    double GetCorrTypeIII( double r, double theta, double psi, int icomp );

  };
}
