#include <iostream>
#include <signal.h>
#include "Es.h"
#include "IoAuger.h"
#include "STCconstants.h"

int main(int argc, char *argv[]) {
  if (argc==1) {
    cout << "Usage: " << argv[0] << " <files>" << endl;
    cout << "   will evaluate the T4 algorithm on each invent and ";
    cout << " produce an output file (T4.root in verbose mode) of the selected events ";
    cout << " with a modifeed trigger algo name. " << endl;
    return 1;
  }
  AugerIoSd input(argc - 1, argv + 1);        //creates the object holding the files
  int n=input.LastEvent();
  for (EventPos pos = input.FirstEvent(); pos < input.LastEvent();
       pos = input.NextEvent()) {
    if (pos%100==0) cerr << pos << "/" << n << " done" << endl;
    TEsEvent event(pos);
    cout << event.Id << " ";
    cout << event.IsT4() << " ";
    cout << event.IsT5() << " ";
    event.OfficialSelection();
    cout << event.fSelectedStations.size() << " ";
    cout << endl;
    /*
        for (unsigned int i=0;i<event.fSeeds.size();i++)
          cout << event.Id << " " << event.fSeeds[i].fTot << " " << event.fSeeds[i].fStations[0]->Id << " " << event.fSeeds[i].fStations[1]->Id << " " << event.fSeeds[i].fStations[2]->Id << " " << event.fSeeds[i].W() << endl;
    */
  }
  return 0;
};
