#include <iostream>
#include <signal.h>
#include <IoAuger.h>
#include "Er.h"
#include "SdRecTest.h"
#include "SdRecLpnhe.h"

int main (int argc, char *argv[]) {
  if (argc==1) {
    cout << "Usage: " << argv[0] << " <files>" << endl;
    cout << "   will produce a verbose output of the content of each file and reconstruct the Sd part." << endl;
    return 1;
  }

  AugerIoSd input(argc-1, argv+1); //creates the object holding the files

  SdRecTest rec;    // creates the test reconstructor

  for (EventPos pos=input.FirstEvent(); pos<input.LastEvent(); pos=input.NextEvent()) {
    TErEvent event(pos);
    if (event.OfficialSelection()) { // cleans accidentals, real event
      rec.Reconstruct(event);
      cout << event.Id << " " << rec.fXCore << endl;
    }
  }

  return 0;
}
