#include "SdRecTest.h"

bool SdRecTest::_Reconstruct(TErEvent & ev) {
  // Here should come the code doing the reconstruction of the TErEvent ev
  // Has to provide data for the TShowerParams

  // Let's fill it with (random parameters):
  // - xcore, ycore = barycenter
  // - u,v,t0,xmax = 0
  // - s1000 = average of signals
  // - E = s1000 * sqrt(number of tanks)
  // - varcov matrix and de=0
  // - add a special parameter myextraparam = number of tanks selected
  // and consider a good reconstruction if more than 4 tanks

  // Here comes the "reconstruction"
  double x = 0, y = 0, s = 0;
  int n = ev.fSelectedStations.size();
  for (unsigned int i = 0; i < ev.fSelectedStations.size(); i++) {
    x += ev.fSelectedStations[i]->fX;
    y += ev.fSelectedStations[i]->fY;
    s += ev.fSelectedStations[i]->fSigInVEM;
  }

  // Filling fRec after the "reconstruction" with its results
  fXCore = x / n;
  fYCore = y / n;
  fSRef = s / n;
  fU = fV = fXmax = 0.0;
  fT0 = 0;
  fE = fSRef * sqrt(1. * n);
  fdE = 0;
  for (int i = 0; i < 7; i++)
    for (int j = 0; j < 7; j++)
      fVarCov[i][j] = 0;
  myextraparam = n;

  // return status of reconstruction
  return (n > 4);
}
