
#include <iostream>
#include <cstring>
#include "STClibrary.h"
#include "TCdasUtil.h"
#include "TSTSky.h"

using namespace std;

int main (int argc, char **argv) {

  float         theta,phi;
  unsigned int  time;
  TSTSky        sky;

#define GO \
    sky.SetPoint(time,theta*kCdasUtil::DEG2RAD,phi*kCdasUtil::DEG2RAD);\
    cout << sky.GetL() << "\t" << sky.GetB() << endl

  if ( argc-1 )  {
    if ( ! strcmp(argv[1],"--") ) {
      while ( cin >> theta >> phi >> time ) { 
        GO;
      }
      return 0;
    }
  }
  else {
    if ( argc < 4 ) {
      cerr << "Not enough args. Theta (in deg), Phi (in deg), Time (in utc)." << endl;
      cerr << "Or auger2bl.exe -- for stdin theta phi and time." << endl;
      exit(1);
    }
  }

  theta = atof(argv[1]); 
  phi   = atof(argv[2]);
  time  = atoi(argv[3]);
  
  GO ;

  return 0;
}
