#include <iostream>
#include <IoAuger.h>

// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//
// // command line for all files of 1, 2 and 3 may as input:
// // [shell]> ./analyse.exe $(DATAPATH)/2002/05/eb_2002_05_0[123]*.root
// // command line for all inputs:
// // [shell]> ./analyse.exe $(DATAPATH)/*/*/*.root
// /**************************************************************************/


int main (int argc, char *argv[]) {
  if (argc==1) {
    std::cout << std::endl;
    std::cout << "Usage: " << argv[0] << " <files>" << std::endl << std::endl;
    std::cout << "  Will read the sd event part of <files> \"a la IoSd\" indenpendently of their original" << endl;
    std::cout << "  format (AugerEvent files or IoSdEvent files or even mixed on the input line !!). "<< std::endl;
    std::cout << "  For each event read, outputs its key and its RootClass." << std::endl;
    return 1;
  }
  AugerIoSd input(argc-1, argv+1);

  EventPos pos;
  for (pos=input.FirstEvent(); pos<input.LastEvent(); pos=input.NextEvent()) {
    IoSdEvent event(pos);
    cout << "Event AugerId "<< event.AugerId<< " (with Sd Id "<< event.Id<<") of class "<<  event.RootClassName;
    cout <<" has key :\"" << event.Key() <<"\"" << endl;
  }
  return 0;
}
