#include "math.h"
#include "Er.h"
#include "IoAuger.h"
#include "TCdasUtil.h"
#include "SdRecLpnhe.h"

using namespace std;

int main (int argc, char *argv[]) {
  AugerIoSd input (argc-1, argv+1);
  IoSd output("public.root","w");
  int nb=input.LastEvent();
  int oid=0;
  for(EventPos pos=input.FirstEvent(); pos<input.LastEvent(); pos=input.NextEvent()) {
    if (!(pos%10000))
      cerr << pos*100/nb << " % done" << endl;
    IoSdEvent eventio(pos);
    if (eventio.Id%100!=0) continue;
    TErEvent event(eventio);
    if (!event.IsT4()) continue;
    event.OfficialSelection();
    if (!event.IsT5()>1) continue;
    theLpnheRec().SetDefault();
    theLpnheRec().SetVerbosity(0);

    theLpnheRec().SetRec(eGeomOptimal, eLDFOptimal);
    int ret=event.Reconstruct(&theLpnheRec());

    // Print result
    if (compute_energy("CIC",event.fRec.fSRef,event.fRec.Theta(),1)>50 && event.fRec.Theta("deg")<60) cerr << "Event " << event.AugerId<< " rejected by energy cut" << endl;
    if (!ret || (!(event.fRec.Theta()>=0 && event.fRec.Theta("deg")<60)) || (!(event.fRec.fE>0)) || (!(event.fRec.fSRef>=0)) || (compute_energy("CIC",event.fRec.fSRef,event.fRec.Theta(),1)>50) || (event.IsT5()<2)) continue;
    else {
      int id=event.Id;
      if (id<oid) continue;
      oid=id;
      if (event.UTCTime>1344604966 && id<10000000) id=id+17000000;
      cout<<id<< " " << event.fSelectedStations.size() << " " << event.fRec.LocalTheta("deg") << " " << event.fRec.LocalPhi("deg") << " " << compute_energy("CIC",event.fRec.fSRef,event.fRec.Theta(),1) << " " << event.UTCTime << " " << event.fRec.L() << " " << event.fRec.B() << endl;
      output.Write(event);
    }
  }
}
